#!/usr/bin/python

from mininet.net import Mininet
from mininet.node import Controller, RemoteController, OVSKernelSwitch, IVSSwitch, UserSwitch
from mininet.link import Link, TCLink
from mininet.cli import CLI
from mininet.log import setLogLevel
from time import sleep
from string import Template
import random
import datetime
import time
import sys
import os
import os.path
from os import path

def check():
    if path.exists('/home/rezmo/opendaylight/ACK.txt'):
	    with open('/home/rezmo/opendaylight/ACK.txt') as f:
		datafile = f.readlines()
	    found = False  
	    for line in datafile:
		if "OK" in line:
		    return True
    return False

def topology():

        "Create a network."
        net = Mininet( controller=Controller, link=TCLink, switch=OVSKernelSwitch )

        print "*** Creating nodes (Switches)"
        s1 = net.addBaseStation( 's1', ssid="MY_SSID", mode="g", channel="1")
        s2 = net.addSwitch( 's2', listenPort=6674, mac='00:00:00:00:00:02' )
        s3 = net.addSwitch( 's3', listenPort=6675, mac='00:00:00:00:00:03'  )
        s4 = net.addBaseStation( 's4',  ssid="MY_SSID", mode="g", channel="6" )
        s5 = net.addSwitch( 's5', listenPort=6677, mac='00:00:00:00:00:05'  )
        s6 = net.addSwitch( 's6', listenPort=6678, mac='00:00:00:00:00:06'  )
        s7 = net.addSwitch( 's7', listenPort=6679, mac='00:00:00:00:00:07'  )
        s8 = net.addSwitch( 's8', listenPort=6680, mac='00:00:00:00:00:08'  )
        s9 = net.addBaseStation( 's9',  ssid="MY_SSID", mode="g", channel="11"  )
        s10 = net.addSwitch( 's10', listenPort=6682, mac='00:00:00:00:00:10'  )
        s11= net.addSwitch( 's11', listenPort=6683, mac='00:00:00:00:00:11'  )
        s12= net.addSwitch( 's12', listenPort=6684, mac='00:00:00:00:00:12'  )
        s13= net.addSwitch( 's13', listenPort=6685, mac='00:00:00:00:00:13'  )
        s14= net.addSwitch( 's14', listenPort=6686, mac='00:00:00:00:00:14'  )
        s15= net.addSwitch( 's15', listenPort=6687, mac='00:00:00:00:00:15'  )
        s16= net.addSwitch( 's16', listenPort=6688, mac='00:00:00:00:00:16'  )
        s17= net.addSwitch( 's17', listenPort=6689, mac='00:00:00:00:00:17'  )
        s18= net.addSwitch( 's18', listenPort=6690, mac='00:00:00:00:00:18'  )
        s19= net.addBaseStation( 's19',  ssid="MY_SSID", mode="g", channel="6"  )
        s20= net.addSwitch( 's20', listenPort=6692, mac='00:00:00:00:00:20'  )
        s21= net.addSwitch( 's21', listenPort=6699, mac='00:00:00:00:00:27'  )
        s22= net.addSwitch( 's22', listenPort=6694, mac='00:00:00:00:00:22'  )
        s23= net.addSwitch( 's23', listenPort=6695, mac='00:00:00:00:00:23'  )
        s24= net.addSwitch( 's24', listenPort=6695, mac='00:00:00:00:00:24'  )
        s25= net.addSwitch( 's25',  listenPort=6695, mac='00:00:00:00:00:25' )
        s26= net.addSwitch( 's26', listenPort=6698, mac='00:00:00:00:00:26'  )
        s27= net.addSwitch( 's27', listenPort=6699, mac='00:00:00:00:00:27'  )
        s28= net.addBaseStation( 's28',  ssid="MY_SSID", mode="g", channel="11"  )
        s29= net.addSwitch( 's29', listenPort=6798, mac='00:00:00:00:00:29'  )
        s30= net.addSwitch( 's30', listenPort=6799, mac='00:00:00:00:00:30'  )
	
	print "*** Creating APs"
	
        AP1 = net.addBaseStation( 's31', ssid="MY_SSID", mode="g", channel="1" )
        AP2 = net.addBaseStation( 's32', ssid="MY_SSID", mode="g", channel="11" )
        AP3 = net.addBaseStation( 's33', ssid="MY_SSID", mode="g", channel="1" )
        AP4 = net.addBaseStation( 's34', ssid="MY_SSID", mode="g", channel="11" )
        AP5 = net.addBaseStation( 's35', ssid="MY_SSID", mode="g", channel="1" )
        AP6 = net.addBaseStation( 's36', ssid="MY_SSID", mode="g", channel="11" )
        AP7 = net.addBaseStation( 's37', ssid="MY_SSID", mode="g", channel="1" )
        AP8 = net.addBaseStation( 's38', ssid="MY_SSID", mode="g", channel="6" )
        AP9 = net.addBaseStation( 's39', ssid="MY_SSID", mode="g", channel="1" )
        AP10 = net.addBaseStation( 's40', ssid="MY_SSID", mode="g", channel="11" )
        AP11 = net.addBaseStation( 's41', ssid="MY_SSID", mode="g", channel="1" )
        AP12 = net.addBaseStation( 's42', ssid="MY_SSID", mode="g", channel="6" )
        AP13 = net.addBaseStation( 's43', ssid="MY_SSID", mode="g", channel="1" )
        AP14 = net.addBaseStation( 's44', ssid="MY_SSID", mode="g", channel="6" )
	
	print "*** Creating Hosts"

        h1 = net.addStation( 'h1')
        h2 = net.addStation( 'h2')
        h3 = net.addStation( 'h3')
        h4 = net.addStation( 'h4')
        h5 = net.addStation( 'h5')
        h6 = net.addStation( 'h6')
        h7 = net.addStation( 'h7')
        h8 = net.addStation( 'h8')
        h9 = net.addStation( 'h9')
        h10 = net.addStation( 'h10')
        h11 = net.addStation( 'h11')
        h12 = net.addStation( 'h12')
        h13 = net.addStation( 'h13')
        h14 = net.addStation( 'h14')
        h15 = net.addStation( 'h15')
        h16 = net.addStation( 'h16')
        h17 = net.addStation( 'h17')
        h18 = net.addStation( 'h18')
        h19 = net.addStation( 'h19')
        h20 = net.addStation( 'h20')
        h21 = net.addStation( 'h21')
        h22 = net.addStation( 'h22')
        h23 = net.addStation( 'h23')
        h24 = net.addStation( 'h24')
        h25 = net.addStation( 'h25')
        h26 = net.addStation( 'h26')
        h27 = net.addStation( 'h27')
        h28 = net.addStation( 'h28')

        c1 = net.addController( 'c1', controller=RemoteController, ip='127.0.0.1', port=6633 )

	print "*** Creating links between Switches"
        net.addLink(s1, s6)
	net.addLink(s1, s2)
	net.addLink(s1, s3)
	net.addLink(s2, s3)
	net.addLink(s2, s7)
	net.addLink(s2, s8,4,1)
	net.addLink(s4, s3)
	net.addLink(s4, s5)
	net.addLink(s4, s6)
	net.addLink(s4, s9)
	net.addLink(s4, s10)
	net.addLink(s5, s6)
	net.addLink(s5, s10)
	net.addLink(s7, s8,2,2)
	net.addLink(s7, s11)
	net.addLink(s9, s8)
	net.addLink(s8, s12)
	net.addLink(s9, s10)
	net.addLink(s9, s13)
	net.addLink(s10, s14)
	net.addLink(s11, s12)
	net.addLink(s11, s18,3,1)
	net.addLink(s12, s13)
	net.addLink(s12, s18,4,2)
	net.addLink(s12, s17)
	net.addLink(s13, s14)
	net.addLink(s13, s17,4,2)
	net.addLink(s13, s16)
	net.addLink(s14, s15,3,1)
	net.addLink(s14, s16,4,2)
	net.addLink(s15, s16)
	net.addLink(s15, s22)
	net.addLink(s21, s16)
	net.addLink(s16, s17,5,3)
	net.addLink(s17, s20)
	net.addLink(s17, s18)
	net.addLink(s19, s18)
	net.addLink(s19, s20)
	net.addLink(s19, s26)
	net.addLink(s21, s20)
	net.addLink(s20, s25,4,1)
	net.addLink(s20, s24,5,1)
	net.addLink(s21, s22)
	net.addLink(s21, s24)
	net.addLink(s22, s23)
	net.addLink(s23, s24)
	net.addLink(s24, s25)
	net.addLink(s24, s29)
	net.addLink(s24, s30)
	net.addLink(s25, s26)
	net.addLink(s28, s25)
	net.addLink(s26, s27)
	net.addLink(s28, s27)
	net.addLink(s28, s29)
	net.addLink(s29, s30)
	print "*** Creating links between Switches and APs"
	net.addLink(AP1, s1)
	net.addLink(AP2, s1)
	net.addLink(AP3, s1)
	net.addLink(AP4, s6)
	net.addLink(AP5, s6)
	net.addLink(AP6, s6)
	net.addLink(AP7, s6)
	net.addLink(AP8, s6)
	net.addLink(AP9, s27)
	net.addLink(AP10, s27)
	net.addLink(AP11, s27)
	net.addLink(AP12, s27)
	net.addLink(AP13, s30)
	net.addLink(AP14, s30)
	print "*** Creating links between Hosts and APs"
	net.addLink(AP1, h1)
	net.addLink(AP1, h2)
	net.addLink(AP2, h3)
	net.addLink(AP2, h4)
	net.addLink(AP3, h5)
	net.addLink(AP3, h6)
	net.addLink(AP4, h7)
	net.addLink(AP4, h8)
	net.addLink(AP5, h9)
	net.addLink(AP5, h10)
	net.addLink(AP6, h11)
	net.addLink(AP6, h12)
	net.addLink(AP7, h13)
	net.addLink(AP7, h14)
	net.addLink(AP8, h15)
	net.addLink(AP8, h16)
	net.addLink(AP9, h17)
	net.addLink(AP9, h18)
	net.addLink(AP10, h19)
	net.addLink(AP10, h20)
	net.addLink(AP11, h21)
	net.addLink(AP11, h22)
	net.addLink(AP12, h23)
	net.addLink(AP12, h24)
	net.addLink(AP13, h25)
	net.addLink(AP13, h26)
	net.addLink(AP14, h27)
	net.addLink(AP14, h28)
	 
        print "*** Starting network"
        net.build()
        c1.start()
        s4.start( [c1] )
        s5.start( [c1] )
        s3.start( [c1] )
        s2.start( [c1] )
        s1.start( [c1] ) 
        s6.start( [c1] ) 
        s7.start( [c1] ) 
        s8.start( [c1] ) 
        s9.start( [c1] ) 
        s10.start( [c1] ) 
        s11.start( [c1] ) 
        s12.start( [c1] ) 
        s13.start( [c1] ) 
        s14.start( [c1] ) 
        s15.start( [c1] ) 
        s16.start( [c1] ) 
        s17.start( [c1] ) 
        s18.start( [c1] ) 
        s20.start( [c1] ) 
        s21.start( [c1] ) 
        s22.start( [c1] ) 
        s23.start( [c1] ) 
        s24.start( [c1] ) 
        s25.start( [c1] ) 
        s26.start( [c1] ) 
        s27.start( [c1] ) 
        s28.start( [c1] ) 
        s29.start( [c1] ) 
        s30.start( [c1] ) 
	AP1.start( [c1] ) 
	AP2.start( [c1] ) 
	AP3.start( [c1] ) 
	AP4.start( [c1] ) 
	AP5.start( [c1] ) 
	AP6.start( [c1] ) 
	AP7.start( [c1] ) 
	AP8.start( [c1] ) 
	AP9.start( [c1] ) 
	AP10.start( [c1] ) 
	AP11.start( [c1] ) 
	AP12.start( [c1] ) 
	AP13.start( [c1] ) 
	AP14.start( [c1] ) 

	
        # below loop is used to inform the controller about all hosts before loading the module
        for w in net.hosts:
           h1.cmd('ping -c 1 -W 1 %s ' % w.IP())
        #cmd = 'cp routing.MY_TE_TECH-0.4.1-SNAPSHOT.jar /home/rezmo/opendaylight/plugins/routing.MY_TE_TECH-0.4.1-SNAPSHOT.jar'
        #os.system(cmd)
        #remove Previous STOP Command
        cmd="rm -f /home/rezmo/opendaylight/ACK.txt"
        os.system(cmd)
        cmd="sed '/STOP/d' /home/rezmo/opendaylight/Inputs.txt  > temp.txt"
        os.system(cmd)
        cmd="cat temp.txt > /home/rezmo/opendaylight/Inputs.txt"
        os.system(cmd)
        cmd="sed '/START/d' /home/rezmo/opendaylight/Inputs.txt  > temp.txt"
        os.system(cmd)
        cmd="cat temp.txt > /home/rezmo/opendaylight/Inputs.txt"
        os.system(cmd)
        cmd = "echo \"START\" >> /home/rezmo/opendaylight/Inputs.txt"
        os.system(cmd)
        sleep(5)
        if "Normal" in str(sys.argv[5]):
		cmd = "echo \"OK\" >> /home/rezmo/opendaylight/ACK.txt"
		os.system(cmd)
        
        #wait till the controller installs a path 
        while True:
            ret=check()
            print "Be Patinet till the controller installs the paths!!"
            if ret==True:
               break
        #input ('enter a key to start=')

        # below loop is used to Set Energy and tx/rx power for the hosts
        for w in net.hosts:
           h1.cmd('python ./IoTDeviceMain.py '+str(w)+' 2 1 100 &')

        h1.cmd("java UDP_SERVER_UNI 2 10001 10.0.0.25 > SERVER_SENDING1.log &")
        h25.cmd("java UDP_Client_UNI  10001  >> result1.txt &")           
        h2.cmd("java UDP_SERVER_UNI 2 10001 10.0.0.26 > SERVER_SENDING2.log &")
        h26.cmd("java UDP_Client_UNI 10001  >> result2.txt &")           
        h3.cmd("java UDP_SERVER_UNI 2 10001 10.0.0.27 > SERVER_SENDING3.log &")
        h27.cmd("java UDP_Client_UNI  10001  >> result3.txt &")                
        h4.cmd("java UDP_SERVER_UNI 2 10001 10.0.0.28 > SERVER_SENDING4.log &")
        h28.cmd("java UDP_Client_UNI 10001  >> result4.txt &")                
        h5.cmd("java UDP_SERVER_UNI 2 20001 10.0.0.25 > SERVER_SENDING5.log &")
        h25.cmd("java UDP_Client_UNI  20001  >> result5.txt &")           	
        h6.cmd("java UDP_SERVER_UNI 2 20001 10.0.0.26 > SERVER_SENDING6.log &")        
	h26.cmd("java UDP_Client_UNI  20001  >> result6.txt &")           
	
	h7.cmd("java UDP_SERVER_UNI 2 10001 10.0.0.17 > SERVER_SENDING7.log &")
        h17.cmd("java UDP_Client_UNI  10001  >> result7.txt &")           
        h8.cmd("java UDP_SERVER_UNI 2 10001 10.0.0.18 > SERVER_SENDING8.log &")
        h18.cmd("java UDP_Client_UNI 10001  >> result8.txt &")           
        h9.cmd("java UDP_SERVER_UNI 2 10001 10.0.0.19 > SERVER_SENDING9.log &")
        h19.cmd("java UDP_Client_UNI  10001  >> result9.txt &")                
        h10.cmd("java UDP_SERVER_UNI 2 10001 10.0.0.20 > SERVER_SENDING10.log &")
        h20.cmd("java UDP_Client_UNI 10001  >> result10.txt &")                
        h11.cmd("java UDP_SERVER_UNI 2 10001 10.0.0.21 > SERVER_SENDING11.log &")
        h21.cmd("java UDP_Client_UNI  10001  >> result11.txt &")           	
        h12.cmd("java UDP_SERVER_UNI 2 10001 10.0.0.22 > SERVER_SENDING12.log &")        
	h22.cmd("java UDP_Client_UNI  10001  >> result12.txt &")
        h13.cmd("java UDP_SERVER_UNI 2 10001 10.0.0.23 > SERVER_SENDING13.log &")        
	h23.cmd("java UDP_Client_UNI  10001  >> result13.txt &")
        h14.cmd("java UDP_SERVER_UNI 2 10001 10.0.0.24 > SERVER_SENDING14.log &")        
	h24.cmd("java UDP_Client_UNI  10001  >> result14.txt &")
        h15.cmd("java UDP_SERVER_UNI 2 20001 10.0.0.17 > SERVER_SENDING15.log &")        
	h17.cmd("java UDP_Client_UNI  20001  >> result15.txt &")
        h16.cmd("java UDP_SERVER_UNI 2 20001 10.0.0.18 > SERVER_SENDING16.log &")        
	h18.cmd("java UDP_Client_UNI  20001  >> result16.txt &")	

           
        abort_after =int(sys.argv[1]) 
        fail_time=int(sys.argv[3])*2
        fail_interval=int(sys.argv[2])
        #shared Links	
        fail_item1 = ["sudo ip link set s2-eth4 down","sudo ip link set s8-eth1 down"]
        fail_item2 = ["sudo ip link set s7-eth2 down","sudo ip link set s8-eth2 down"]
	
        fail_item3 = ["sudo ip link set s11-eth3 down","sudo ip link set s18-eth1 down"]
        fail_item4 = ["sudo ip link set s12-eth4 down","sudo ip link set s18-eth2 down"]
	
        fail_item5 = ["sudo ip link set s14-eth3 down","sudo ip link set s15-eth1 down"]
        fail_item6 = ["sudo ip link set s14-eth4 down","sudo ip link set s16-eth2 down"]
	
        fail_item7 = ["sudo ip link set s13-eth4 down","sudo ip link set s17-eth2 down"]
        fail_item8 = ["sudo ip link set s16-eth5 down","sudo ip link set s17-eth3 down"]
	
        fail_item9 = ["sudo ip link set s20-eth5 down","sudo ip link set s24-eth1 down"]
        fail_item10 = ["sudo ip link set s20-eth4 down","sudo ip link set s25-eth1 down"]
	
        fail_flag=0
        start = time.time()
        temp1=time.time()
        temp2=0
        temp_time=time.time()
        while True:
                resultta = time.time() - start
	        if resultta >= abort_after:
	            break
		
		temp_fail=time.time() - temp_time
                #print temp_fail +"   "+time.time()
		if temp_fail >= fail_interval:
                 if fail_flag==0:
		    temp_time=time.time()
           	    print "All links DOWN at" +str(time.time())
		    r1=random.choice(fail_item1)
		    r2=random.choice(fail_item2)
		    r3=random.choice(fail_item3)
		    r4=random.choice(fail_item4)
		    r5=random.choice(fail_item5)
		    r6=random.choice(fail_item6)
		    r7=random.choice(fail_item7)
		    r8=random.choice(fail_item8)
		    r9=random.choice(fail_item9)
		    r10=random.choice(fail_item10)
		    temp1=time.time()
		    os.system(r1)
		    os.system(r2)
		    os.system(r3)
		    os.system(r4)
		    os.system(r5)
		    os.system(r6)
		    os.system(r7)
		    os.system(r8)
		    os.system(r9)
		    os.system(r10)
		    fail_flag=1
			
	        temp2=time.time() - temp1
		if temp2 >= fail_time and fail_flag==1:
                        print str(temp_fail) +"   "+str(time.time())
			fail_flag=0
			print "All links UP at" +str(time.time())
			os.system("sudo ip link set s2-eth4 up")
			os.system("sudo ip link set s8-eth1 up")
			os.system("sudo ip link set s7-eth2 up")
			os.system("sudo ip link set s8-eth2 up")
			os.system("sudo ip link set s11-eth3 up")
			os.system("sudo ip link set s18-eth1 up")
			os.system("sudo ip link set s18-eth2 up")
			os.system("sudo ip link set s12-eth4 up")
			os.system("sudo ip link set s14-eth3 up")
			os.system("sudo ip link set s15-eth1 up")
			os.system("sudo ip link set s14-eth4 up")
			os.system("sudo ip link set s16-eth2 up")
			os.system("sudo ip link set s13-eth4 up")
			os.system("sudo ip link set s17-eth2 up")
			os.system("sudo ip link set s16-eth5 up")
			os.system("sudo ip link set s17-eth3 up")
			os.system("sudo ip link set s20-eth5 up")
			os.system("sudo ip link set s24-eth1 up")
			os.system("sudo ip link set s20-eth4 up")
			os.system("sudo ip link set s25-eth1 up")

        #CLI( net )
        for i in range(1,17):
		cmd = 'mv result'+str(i)+'.txt results/'+str(sys.argv[5])+'/rec_result_'+str(i)+'_'+str(sys.argv[4])+'_'+str(sys.argv[6])+'.txt'
		os.system(cmd)
		cmd = 'mv SERVER_SENDING'+str(i)+'.log results/'+str(sys.argv[5])+'/send_SERVER'+str(i)+'_'+str(sys.argv[4])+'_'+str(sys.argv[6])+'.log'
		os.system(cmd)
		
        cmd = "echo \"STOP\" >> /home/rezmo/opendaylight/Inputs.txt"
        os.system(cmd)
        sleep(5)
        net.stop()
if __name__ == '__main__':
        setLogLevel( 'info' )
        topology()



