package org.opendaylight.controller.routing.MY_TE_TECH.internal;
import org.opendaylight.controller.clustering.services.IClusterContainerServices;
import org.opendaylight.controller.sal.core.Bandwidth;
import org.opendaylight.controller.sal.core.ConstructionException;
import org.opendaylight.controller.sal.core.Edge;
//import org.opendaylight.controller.sal.core.Latency;
import org.opendaylight.controller.sal.core.Node;
import org.opendaylight.controller.sal.core.NodeConnector;
import org.opendaylight.controller.sal.core.Path;
import org.opendaylight.controller.sal.core.Property;
import org.opendaylight.controller.sal.core.UpdateType;
import org.opendaylight.controller.sal.routing.IListenRoutingUpdates;
import org.opendaylight.controller.sal.routing.IRouting;
import org.opendaylight.controller.sal.topology.TopoEdgeUpdate;
//import org.opendaylight.controller.forwardingrulesmanager.FlowEntry;
import org.opendaylight.controller.hosttracker.hostAware.HostNodeConnector;
import org.opendaylight.controller.hosttracker.IfIptoHost;
import org.opendaylight.controller.sal.utils.ServiceHelper;
import org.opendaylight.controller.statisticsmanager.IStatisticsManager;
import org.opendaylight.controller.switchmanager.ISwitchManager;
import org.opendaylight.controller.topologymanager.ITopologyManager;
import org.opendaylight.controller.topologymanager.ITopologyManagerClusterWideAware;
import org.opendaylight.controller.sal.packet.RawPacket;
import org.opendaylight.controller.sal.packet.PacketResult;
import org.opendaylight.controller.sal.flowprogrammer.IFlowProgrammerService;
import org.opendaylight.controller.sal.reader.IReadService;
import org.opendaylight.controller.sal.reader.NodeConnectorStatistics;
import org.opendaylight.controller.sal.packet.IDataPacketService;
import org.opendaylight.controller.sal.action.Action;
import org.opendaylight.controller.sal.action.Output;
import org.opendaylight.controller.sal.flowprogrammer.Flow;
import org.opendaylight.controller.sal.match.Match;
import org.opendaylight.controller.sal.match.MatchType;
import org.opendaylight.controller.sal.packet.Ethernet;
import org.opendaylight.controller.sal.packet.Packet;
import org.opendaylight.controller.sal.utils.Status;

import java.util.ArrayList;
import java.util.Timer;
import java.util.TimerTask;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
//import java.util.ArrayList;
import java.util.Set;
import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;
import java.util.concurrent.ConcurrentMap;

import org.opendaylight.controller.sal.packet.IListenDataPacket;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.apache.commons.collections15.Transformer;

import BaseLib.BaseVertex;
import Yen_K_Path.Vertex;
import edu.uci.ics.jung.algorithms.shortestpath.DijkstraShortestPath;
import edu.uci.ics.jung.graph.Graph;
import edu.uci.ics.jung.graph.SparseMultigraph;
import edu.uci.ics.jung.graph.util.EdgeType;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.net.InetAddress;
import java.net.UnknownHostException;
import java.nio.ByteBuffer;
import java.util.LinkedList;
import java.util.Date;
@SuppressWarnings("rawtypes")
public class MY_TE_TECH implements IRouting, ITopologyManagerClusterWideAware,IListenDataPacket {
      private static Logger log = LoggerFactory.getLogger(MY_TE_TECH.class);
      private ConcurrentMap<Short, Graph<Node, Edge>> topologyBWAware;
      private ConcurrentMap<Short, DijkstraShortestPath<Node, Edge>> sptBWAware;
      DijkstraShortestPath<Node, Edge> mtp; // Max Throughput Path
      private Set<IListenRoutingUpdates> routingAware;
      private ISwitchManager switchManager;
      private ITopologyManager topologyManager;
      private static final long DEFAULT_LINK_SPEED = Bandwidth.BW1Gbps;
      private IClusterContainerServices clusterContainerService;
      private Timer MyTimer;
      private TimerTask MyTimerTask;
      private Timer MyTimer2;
      private TimerTask MyTimerTask2;
      private IReadService readService;
      private IDataPacketService dataPacketService;
      private IFlowProgrammerService flowProgrammerService;
      private IfIptoHost iptohost;
      int[][] delay_matrix;
      int[][] LINKS;
      double[][] node_matrix;
      String[][] HostsTrack;
      boolean[] q;
      int COUNT=0; // This variable has been considered for eliminating the problem of Yen algorithm
      int[][] prev_paths;
      long pre_transmit1=0,pre_transmit2=0;
      boolean fail_flag=false;
      boolean first_time=false;
      boolean stoprefresh=false;
      boolean startrefresh=false;
      boolean success_path=false;
      int total_count=0;
      int interval_time=5000;
      int max_hosts=40;
      String Algorithm="Normal";
   void setDataPacketService1(IDataPacketService s) {
       log.trace("Set DataPacketService.");
       dataPacketService = s;
      }
      /**
       * Unsets DataPacketService
       */
      void unsetDataPacketService1(IDataPacketService s) {
       log.trace("Removed DataPacketService.");

       if (dataPacketService == s) {
     dataPacketService = null;
       }
      }
      /**
       * Sets a reference to the requested FlowProgrammerService
       */
      void setFlowProgrammerService(IFlowProgrammerService s) {
       log.trace("Set FlowProgrammerService.");

       flowProgrammerService = s;
      }
      /**
       * Unsets FlowProgrammerService
       */
      void unsetFlowProgrammerService(IFlowProgrammerService s) {
       log.trace("Removed FlowProgrammerService.");

       if (flowProgrammerService == s) {
     flowProgrammerService = null;
       }
      }
      /**
       * Sets a reference to the requested SwitchManagerService
       */
      void setSwitchManagerService(ISwitchManager s) {
       log.trace("Set SwitchManagerService.");

       switchManager = s;
      }
      /**
       * Unsets SwitchManagerService
       */
      void unsetSwitchManagerService(ISwitchManager s) {
       log.trace("Removed SwitchManagerService.");

       if (switchManager == s) {
     switchManager = null;
       }
      }
      public void setListenRoutingUpdates(final IListenRoutingUpdates i) {
       if (this.routingAware == null) {
     this.routingAware = new HashSet<IListenRoutingUpdates>();
       }
       if (this.routingAware != null) {
     log.debug("Adding routingAware listener: {}", i);
     this.routingAware.add(i);
       }
      }

      public void unsetListenRoutingUpdates(final IListenRoutingUpdates i) {
       if (this.routingAware == null) {
     return;
       }
       log.debug("Removing routingAware listener");
       this.routingAware.remove(i);
       if (this.routingAware.isEmpty()) {
     // We don't have any listener lets dereference
     this.routingAware = null;
       }
      }

public void setReadService(IReadService readService) {
this.readService = readService;
}
public void unsetReadService(IReadService readService) {
if (this.readService == readService) {
this.readService = null;
}
}
public void setSwitchManager(ISwitchManager switchManager) {
    this.switchManager = switchManager;
}

public void unsetSwitchManager(ISwitchManager switchManager) {
    if (this.switchManager == switchManager) {
     this.switchManager = null;
    }
}

public void setTopologyManager(ITopologyManager tm) {
    this.topologyManager = tm;
}

public void unsetTopologyManager(ITopologyManager tm) {
    if (this.topologyManager == tm) {
     this.topologyManager = null;
    }
}

void setClusterContainerService(IClusterContainerServices s) {
    log.debug("Cluster Service set");
    this.clusterContainerService = s;
}

void unsetClusterContainerService(IClusterContainerServices s) {
    if (this.clusterContainerService == s) {
     log.debug("Cluster Service removed!");
     this.clusterContainerService = null;
    }
}

@Override
public void edgeOverUtilized(Edge edge) {
    // TODO Auto-generated method stub

}

@Override
public void edgeUtilBackToNormal(Edge edge) {
    // TODO Auto-generated method stub

}
void setHostTrackerService(IfIptoHost s) {
log.trace("Set HostTrackerService.");
iptohost = s;
}
/**
* Unsets HosttrackerService
*/
void unsetHostTrackerService(IfIptoHost s) {
log.trace("Removed HostTrackerService.");
if (iptohost == s) {
     iptohost = null;
}
}

      static private InetAddress intToInetAddress(int i) {
       byte b[] = new byte[] { (byte) ((i>>24)&0xff), (byte) ((i>>16)&0xff), (byte) ((i>>8)&0xff), (byte) (i&0xff) };
       InetAddress addr;
       try {
     addr = InetAddress.getByAddress(b);
       } catch (UnknownHostException e) {
     return null;
       }
       return addr;
      }

      public MY_TE_TECH() {
      }

 @Override
      public PacketResult receiveDataPacket(RawPacket inPkt) {
     NodeConnector ingressConnector = inPkt.getIncomingNodeConnector();
     //System.out.println(inPkt.toString());
       Node node = ingressConnector.getNode();
       log.trace("Packet from " + node.getNodeIDString() + " " + ingressConnector.getNodeConnectorIDString());
       Packet pkt = dataPacketService.decodeDataPacket(inPkt);
       //System.out.println(pkt);
       if (pkt instanceof Ethernet) {
     Ethernet ethFrame = (Ethernet) pkt;
     Short t=ethFrame.getEtherType();
     if(t==0xfc){
      byte timestamp[]=ethFrame.getRawPayload();
     long z=((long)(inPkt.getIncomingTime().getValue())-bytesToLong(timestamp));
     byte src[]=ethFrame.getSourceMACAddress();
     byte dst[]=ethFrame.getDestinationMACAddress();
      delay_matrix[src[5]-1][dst[5]-1]=(int)z; // The 5th index of array is the node number
     //System.out.println("the delay between "+src[5]+ " and "+dst[5]+" is "+z);
     }
       }
       return PacketResult.IGNORED;
}
      @Override
      public synchronized void initMaxThroughput(final Map<Edge, Number> EdgeWeightMap) {
       if (mtp != null) {
     log.error("Max Throughput Dijkstra is already enabled!");
     return;
       }
       Transformer<Edge, ? extends Number> mtTransformer = null;
       if (EdgeWeightMap == null) {
     mtTransformer = new Transformer<Edge, Double>() {
      @Override
      public Double transform(Edge e) {
      if (switchManager == null) {
       log.error("switchManager is null");
       return (double) -1;
      }
      NodeConnector srcNC = e.getTailNodeConnector();
      NodeConnector dstNC = e.getHeadNodeConnector();
      if ((srcNC == null) || (dstNC == null)) {
       return (double) -1;
      }
      Bandwidth bwSrc = (Bandwidth) switchManager.getNodeConnectorProp(srcNC,
     Bandwidth.BandwidthPropName);
      Bandwidth bwDst = (Bandwidth) switchManager.getNodeConnectorProp(dstNC,
     Bandwidth.BandwidthPropName);
      long srcLinkSpeed = 0, dstLinkSpeed = 0;
      if ((bwSrc == null) || ((srcLinkSpeed = bwSrc.getValue()) == 0)) {
       log.debug("srcNC: {} - Setting srcLinkSpeed to Default!", srcNC);
       srcLinkSpeed = DEFAULT_LINK_SPEED;
      }

      if ((bwDst == null) || ((dstLinkSpeed = bwDst.getValue()) == 0)) {
       log.debug("dstNC: {} - Setting dstLinkSpeed to Default!", dstNC);
       dstLinkSpeed = DEFAULT_LINK_SPEED;
      }
      // TODO: revisit the logic below with the real use case in
      // mind
      // For now we assume the throughput to be the speed of the
      // link itself
      // this kind of logic require information that should be
      // polled by statistic manager and are not yet available,
      // also this service at the moment is not used, so to be
      // revisited later on
     long avlSrcThruPut = srcLinkSpeed- readService.getTransmitRate(srcNC);
     long avlDstThruPut = dstLinkSpeed- readService.getTransmitRate(dstNC);
      // Use lower of the 2 available throughput as the available
      // throughput
      long avlThruPut = avlSrcThruPut < avlDstThruPut ? avlSrcThruPut : avlDstThruPut;

      if (avlThruPut <= 0) {
       log.debug("Edge {}: Available Throughput {} <= 0!", e, avlThruPut);
       return (double) -1;
      }
      return (double) (Bandwidth.BW1Pbps  / avlThruPut);
      }
     };
       } else {
     mtTransformer = new Transformer<Edge, Number>() {
      @Override
      public Number transform(Edge e) {
      return EdgeWeightMap.get(e);
      }
     };
       }
       Short baseBW = Short.valueOf((short) 0);
       // Initialize mtp also using the default topo
       Graph<Node, Edge> g = this.topologyBWAware.get(baseBW);
//System.out.println("the graph is="+g.toString());
       if (g == null) {
     log.error("Default Topology Graph is null");
     return;
       }
       mtp = new DijkstraShortestPath<Node, Edge>(g, mtTransformer);
      }
      @Override
      public Path getRoute(final Node src, final Node dst) {
       if ((src == null) || (dst == null)) {
     return null;
       }
       return getRoute(src, dst, (short) 0);
      }

      @Override
      public synchronized Path getMaxThroughputRoute(Node src, Node dst) {
       if (mtp == null) {
     log.error("Max Throughput Path Calculation Uninitialized!");
     return null;
       }


       List<Edge> path;
       try {
     path = mtp.getMaxThroughputPath(src, dst);
       } catch (IllegalArgumentException ie) {
     log.debug("A vertex is yet not known between {} {}", src, dst);
     return null;
       }
       Path res;
       try {
     res = new Path(path);
       } catch (ConstructionException e) {
     log.debug("A vertex is yet not known between {} {}", src, dst);
     return null;
       }
       return res;
      }

      @Override
      public synchronized Path getRoute(final Node src, final Node dst, final Short Bw) {
       DijkstraShortestPath<Node, Edge> spt = this.sptBWAware.get(Bw);
       if (spt == null) {
     return null;
       }
       List<Edge> path;
       try {
     path = spt.getPath(src, dst);
       } catch (IllegalArgumentException ie) {
     log.debug("A vertex is yet not known between {} {}", src, dst);
     return null;
       }
       Path res;
       try {
     res = new Path(path);
       } catch (ConstructionException e) {
     log.debug("A vertex is yet not known between {} {}", src, dst);
     return null;
       }
       return res;
      }

      @Override
      public synchronized void clear() {
       DijkstraShortestPath<Node, Edge> spt;
       for (Short bw : this.sptBWAware.keySet()) {
     spt = this.sptBWAware.get(bw);
     if (spt != null) {
      spt.reset();
     }
       }
       clearMaxThroughput();
      }

      @Override
      public synchronized void clearMaxThroughput() {
       if (mtp != null) {
     mtp.reset(); // reset max throughput path
       }
      }

      @SuppressWarnings({ "unchecked" })
      private synchronized boolean updateTopo(Edge edge, Short bw, UpdateType type) {
       Graph<Node, Edge> topo = this.topologyBWAware.get(bw);
       DijkstraShortestPath<Node, Edge> spt = this.sptBWAware.get(bw);
       boolean edgePresentInGraph = false;
       Short baseBW = Short.valueOf((short) 0);

       if (topo == null) {
     // Create topology for this BW
     Graph<Node, Edge> g = new SparseMultigraph();

     this.topologyBWAware.put(bw, g);
     topo = this.topologyBWAware.get(bw);
     this.sptBWAware.put(bw, new DijkstraShortestPath(g));
     spt = this.sptBWAware.get(bw);

       }

       if (topo != null) {
     NodeConnector src = edge.getTailNodeConnector();
     NodeConnector dst = edge.getHeadNodeConnector();
     if (spt == null) {
      spt = new DijkstraShortestPath(topo);
      this.sptBWAware.put(bw, spt);
     }
      //  System.out.println("updatetopothe graph is "+topo.toString()+"\n");

     switch (type) {
     case ADDED:
      // Make sure the vertex are there before adding the edge
      topo.addVertex(src.getNode());
      topo.addVertex(dst.getNode());
      // Add the link between
      edgePresentInGraph = topo.containsEdge(edge);
      if (edgePresentInGraph == false) {
      try {
       topo.addEdge(new Edge(src, dst), src.getNode(), dst.getNode(), EdgeType.DIRECTED);
      } catch (final ConstructionException e) {
       log.error("", e);
       return edgePresentInGraph;
      }
      }
     case CHANGED:
      // Mainly raised only on properties update, so not really useful
      // in this case
      break;
     case REMOVED:
      // Remove the edge
      try {
      topo.removeEdge(new Edge(src, dst));
      } catch (final ConstructionException e) {
      log.error("", e);
      return edgePresentInGraph;
      }

      // If the src and dst vertex don't have incoming or
      // outgoing links we can get ride of them
      if (topo.containsVertex(src.getNode()) && (topo.inDegree(src.getNode()) == 0)
       && (topo.outDegree(src.getNode()) == 0)) {
      log.debug("Removing vertex {}", src);
      topo.removeVertex(src.getNode());
      }

      if (topo.containsVertex(dst.getNode()) && (topo.inDegree(dst.getNode()) == 0)
       && (topo.outDegree(dst.getNode()) == 0)) {
      log.debug("Removing vertex {}", dst);
      topo.removeVertex(dst.getNode());
      }
      break;
     }
     spt.reset();
     if (bw.equals(baseBW)) {
      clearMaxThroughput();
     }
       } else {
     log.error("Cannot find topology for BW {} this is unexpected!", bw);
       }
       return edgePresentInGraph;
      }

      private boolean edgeUpdate(Edge e, UpdateType type, Set<Property> props, boolean local) {
       String srcType = null;
       String dstType = null;

       log.trace("Got an edgeUpdate: {} props: {} update type: {} local: {}", new Object[] { e, props, type, local });

       if ((e == null) || (type == null)) {
     log.error("Edge or Update type are null!");
     return false;
       } else {
     srcType = e.getTailNodeConnector().getType();
     dstType = e.getHeadNodeConnector().getType();

     if (srcType.equals(NodeConnector.NodeConnectorIDType.PRODUCTION)) {
      log.debug("Skip updates for {}", e);
      return false;
     }

     if (dstType.equals(NodeConnector.NodeConnectorIDType.PRODUCTION)) {
      log.debug("Skip updates for {}", e);
      return false;
     }
       }

       Bandwidth bw = new Bandwidth(0);
       boolean newEdge = false;
       if (props != null) {
     props.remove(bw);
       }

       Short baseBW = Short.valueOf((short) 0);
       // Update base topo
       newEdge = !updateTopo(e, baseBW, type);
       if (newEdge == true) {
     if (bw.getValue() != baseBW) {
      // Update BW topo
      updateTopo(e, (short) bw.getValue(), type);
     }
       }
       return newEdge;
      }

      @Override
      public void edgeUpdate(List<TopoEdgeUpdate> topoedgeupdateList) {
       log.trace("Start of a Bulk EdgeUpdate with " + topoedgeupdateList.size() + " elements");
       boolean callListeners = false;
       for (int i = 0; i < topoedgeupdateList.size(); i++) {
     Edge e = topoedgeupdateList.get(i).getEdge();
     Set<Property> p = topoedgeupdateList.get(i)
      .getProperty();
     UpdateType type = topoedgeupdateList.get(i)
      .getUpdateType();
     boolean isLocal = topoedgeupdateList.get(i)
      .isLocal();
     if ((edgeUpdate(e, type, p, isLocal)) && (!callListeners)) {
      callListeners = true;
     }
       }

       // The routing listeners should only be called on the coordinator, to
       // avoid multiple controller cluster nodes to actually do the
       // recalculation when only one need to react
       boolean amICoordinator = true;
       if (this.clusterContainerService != null) {
     amICoordinator = this.clusterContainerService.amICoordinator();
       }
       if ((callListeners) && (this.routingAware != null) && amICoordinator) {
     log.trace("Calling the routing listeners");
     for (IListenRoutingUpdates ra : this.routingAware) {
      try {
      ra.recalculateDone();
      } catch (Exception ex) {
      log.error("Exception on routingAware listener call", ex);
      }
     }
       }
       log.trace("End of a Bulk EdgeUpdate");
      }

      /**
       * Function called by the dependency manager when all the required
       * dependencies are satisfied
       *
       */
      @SuppressWarnings({ "unchecked", "rawtypes" })
      public void init() {

     log.debug(" Routing init() is called");
     this.topologyBWAware = (ConcurrentMap<Short, Graph<Node, Edge>>) new ConcurrentHashMap();
     this.sptBWAware = (ConcurrentMap<Short, DijkstraShortestPath<Node, Edge>>) new ConcurrentHashMap();
     Graph<Node, Edge> g = new SparseMultigraph();
     Short sZero = Short.valueOf((short) 0);
      this.topologyBWAware.put(sZero, g);
     this.sptBWAware.put(sZero, new DijkstraShortestPath(g));
      }

/**
       * Function called by the dependency manager when at least one dependency
       * become unsatisfied or when the component is shutting down because for
       * example bundle is being stopped.
       *
       */
      void destroy() {
       log.debug("Routing destroy() is called");
      }

      /**
       * Function called by dependency manager after "init ()" is called and after
       * the services provided by the class are registered in the service registry
       *
       */
      void start() {
     System.out.println("Module is Strating.......................\n");
       log.debug("Routing start() is called");
       this.MyTimer = new Timer();
       q=new boolean[max_hosts];
       int n=20;
       prev_paths=new int[2*max_hosts][n];
       for(int i=0; i<2*max_hosts; i++)
            for(int j=0; j<n; j++)
               prev_paths[i][j]=-1;
     this.MyTimerTask = new TimerTask() {
@SuppressWarnings("static-access")
@Override
       public void run() {
     try {
           TE_Routing();
      }catch(Exception e){System.out.println(" Temprory Exception : "+e);}
     }
      };
      MyTimer.scheduleAtFixedRate(MyTimerTask, 0, interval_time);
      this.MyTimer2 = new Timer();
    this.MyTimerTask2 = new TimerTask() {
@SuppressWarnings("static-access")
@Override
      public void run() {
    stoprefresh();
    }
     };
     MyTimer2.scheduleAtFixedRate(MyTimerTask2, 0, 1000);//1sec
     }

      /**
       * Function called by the dependency manager before the services exported by
       * the component are unregistered, this will be followed by a "destroy ()"
       * calls
       *
       */
      public void stop() {
       log.debug("Routing stop() is called");
      }
public void stoprefresh()
{
     BufferedReader br = null;
     FileReader fr = null;
     boolean find=false;
     boolean findstart=false;
     try {
         fr = new FileReader("Inputs.txt");
         br = new BufferedReader(fr);
         String CurrentLine;
         br = new BufferedReader(new FileReader("Inputs.txt"));
         while ((CurrentLine = br.readLine()) != null) {
             if(CurrentLine.contains("STOP")){
                                     find=true;
                                                  }
             if(CurrentLine.contains("START")){
                 findstart=true;
                              }
         }
      }catch(IOException e){System.out.println(e);}
     if(find)
        {
           stoprefresh=true;
           for(int i=0; i<max_hosts; i++)q[i]=false;
        } else
            {
                stoprefresh=false;
            }
     if(findstart)
              startrefresh=true;
     else
               startrefresh=false;
}
public boolean is_link(int p, int q)
{
   boolean res=false;
   for (int i=0; i<100; i++)
       if((LINKS[i][0]==p && LINKS[i][1]==q)||(LINKS[i][0]==q && LINKS[i][1]==p))res=true;
   return res;
}
public void TE_Routing() throws UnknownHostException
{
              double[][] t=new double[][]{
                      {0,1,1,1,0,0,0,0},
                      {0,0,1,0,0,0,0,0},
                      {0,0,0,1,0,0,1,0},
                      {0,0,0,0,0,0,1,0},
                      {0,0,1,0,0,0,0,1},
                      {0,0,0,0,0,0,0,1},
                      {0,0,0,0,0,1,0,1},
                      {0,0,0,0,0,0,0,0}
                      };
              clearMaxThroughput();
              if(stoprefresh){
                  stoprefresh();
                  return;
              }
              else if(startrefresh)
              {
                    // build the routing database from the topology if it exists.
                    Map<Edge, Set<Property>> edges = topologyManager.getEdges();
                    if (edges.isEmpty()) {System.out.println("no edges");
                  return;
                    }
                    List<TopoEdgeUpdate> topoedgeupdateList = new ArrayList<TopoEdgeUpdate>();
                    log.debug("Creating routing database from the topology");
                    for (Iterator<Map.Entry<Edge, Set<Property>>> i = edges.entrySet()
                   .iterator(); i.hasNext();) {
                  Map.Entry<Edge, Set<Property>> entry = i.next();
                  Edge e = entry.getKey();
                  Set<Property> props = entry.getValue();
                  TopoEdgeUpdate topoedgeupdate = new TopoEdgeUpdate(e, props,
                   UpdateType.ADDED);
                  topoedgeupdateList.add(topoedgeupdate);
                    }
                    edgeUpdate(topoedgeupdateList);

                    String containerName = "default";
                    ISwitchManager switchManager = (ISwitchManager) ServiceHelper.getInstance(ISwitchManager.class, containerName, this);
                    delay_matrix=new int[switchManager.getNodes().size()][switchManager.getNodes().size()];
                    for(int i=0; i<switchManager.getNodes().size(); i++)
                  for(int j=0; j<switchManager.getNodes().size(); j++)
                    delay_matrix[i][j]=0;
                    LINKS=new int[100][2];
                    for(int i=0; i<100; i++)
                    {LINKS[i][0]=-1;LINKS[i][1]=-1;}
              }else {stoprefresh();  return;}
              mtp = null;
              initMaxThroughput(null);
              BufferedReader br = null;
              FileReader fr = null;
              int max_shared_links=20;
              int[][] TSharedLinkGraph=new int[max_shared_links][2];
              String[][] Hosts=new String[max_hosts][2];
              int p=0,r=0,l=0;
              try {
                  fr = new FileReader("Inputs.txt");
                  br = new BufferedReader(fr);
                  String CurrentLine;
                  br = new BufferedReader(new FileReader("Inputs.txt"));
                  while ((CurrentLine = br.readLine()) != null) {
                      if(CurrentLine.contains("Algorithm")){
                      Algorithm=CurrentLine.substring(CurrentLine.indexOf("Algorithm")+11).trim();
                      }
                      if(CurrentLine.contains("Interval:")){
                          interval_time=Integer.valueOf(CurrentLine.substring(CurrentLine.indexOf(":")+1).trim());
                      }
                      if(CurrentLine.contains("Shared:")){
                              TSharedLinkGraph[p][0]=Integer.valueOf(CurrentLine.substring(CurrentLine.indexOf(":")+1,CurrentLine.indexOf(",")).trim());
                              TSharedLinkGraph[p][1]=Integer.valueOf(CurrentLine.substring(CurrentLine.indexOf(",")+1).trim());
                             if(p<max_shared_links)p++;
                      }
                      if(CurrentLine.contains("Pair:")){
                              Hosts[r][0]=CurrentLine.substring(CurrentLine.indexOf(":")+1,CurrentLine.indexOf("*")).trim();
                              Hosts[r][1]=CurrentLine.substring(CurrentLine.indexOf("*")+1).trim();
                             if(r<max_hosts)r++;
                      }
                      if(CurrentLine.contains("--")){
                          LINKS[l][0]=Integer.valueOf(CurrentLine.substring(0,CurrentLine.indexOf("--")).trim());
                          LINKS[l][1]=Integer.valueOf(CurrentLine.substring(CurrentLine.indexOf("--")+2).trim());
                         if(l<100)l++;
                         for(int i=0;i<l;i++)
                                System.out.println(i+" links("+LINKS[i][0]+","+LINKS[i][1]+")");
                  }
                  }
                     System.out.println(Algorithm+" "+interval_time+" "+TSharedLinkGraph[0][0]+" "+Hosts[0][0]);
             }
          catch(IOException e){System.out.println(e);}
              if(!first_time) {
                      System.out.println("..");
                      COUNT=-delay_matrix.length;
                      Default_Routing_For_Hosts();
                      System.out.println("Default Routes have been installed");
                      System.out.println("...");
                      Set<HostNodeConnector> M=iptohost.getAllHosts();
                      HostsTrack=new String[M.size()][2];
                      System.out.println("...."+M.size());
                      Switch_to_Host_Stats_Gathering();
                       System.out.println("Number of hosts="+M.size());}
              if(Algorithm.trim().equals("Normal"))
              {
                  Default_Routing_For_Hosts();
                      System.out.println("Default Routes have been installed");
                  return;
              } else if(Algorithm.trim().equals("FT"))
              {
               Send_Ether_Packet();
               Gather_Stat();
               int[][] SharedLinkGraph=new int[p][2];
               for(int i=0; i<p; i++)
                      {SharedLinkGraph[i][0]=TSharedLinkGraph[i][0];SharedLinkGraph[i][1]=TSharedLinkGraph[i][1];}
               for(int i=0; i<r; i++){
                    if(!q[i])
                       q[i]=Run_Route_SRLG(Hosts[i][0], Hosts[i][1],SharedLinkGraph,p/2,i); // I use this variable to prevent installing path after successful path installation
                    else
                         System.out.println("The path has been Established for "+Hosts[i][0]+" " +Hosts[i][1]);
                   }
               boolean tempflag=false;
               for(int i=0; i<r; i++){
                    if(!q[i]) tempflag=true;
                   }
               if(!tempflag){
                   Write_To_File("OK","ACK.txt");
                   for(int i=0; i<max_hosts; i++)q[i]=false;
                  }

               Check_Hosts_Failure();
              } else if(Algorithm.trim().equals("DP"))
              {
                  Send_Ether_Packet();
                  Gather_Stat();
                  for(int i=0; i<r; i++){
                       if(!q[i])
                          q[i]=Run_Route_Disjoint(Hosts[i][0], Hosts[i][1],i); // I use this variable to prevent installing path after successful path installation
                       else
                            System.out.println("The path has been Established for "+Hosts[i][0]+" " +Hosts[i][1]);
                      }
                  boolean tempflag=false;
                  for(int i=0; i<r; i++){
                       if(!q[i]) tempflag=true;
                      }
                  if(!tempflag){
                      Write_To_File("OK","ACK.txt");
                      for(int i=0; i<max_hosts; i++)q[i]=false;
                     }
                  Check_Hosts_Failure();
              }
        }
public boolean Compare_Path(int[] p1,int[] p2)
{
      if(Path_Cost(p1)<Path_Cost(p2))
           return true;
      else
          return false;
}
public boolean Run_Route_Disjoint(String srcnode,String dstnode,int index) throws UnknownHostException
{
     int Source_addr=0, Dest_addr=0;
     boolean res=false;
     NodeConnector startConnector=null;
     InetAddress clientAddr=null,dstAddr=null;
     Node startNode=null;
     int es1=-1,es2=-1;
     Send_Ether_Packet();
     Gather_Stat();
System.out.println(node_matrix.length);
     try{
        clientAddr = InetAddress.getByName(srcnode);//source node
        dstAddr = InetAddress.getByName(dstnode);//destination node
        HostNodeConnector startHostConnector = iptohost.hostFind(clientAddr);
        HostNodeConnector LastHostConnector = iptohost.hostFind(dstAddr);
        startConnector = startHostConnector.getnodeConnector();
        NodeConnector LastConnector = LastHostConnector.getnodeConnector();
        startNode = startConnector.getNode();
        Node lastNode = LastConnector.getNode();
        long d1=(long)startNode.getID();
        long d2=(long)lastNode.getID();
        Source_addr=(int)d1;
        Dest_addr=(int)d2;
System.out.println(node_matrix.length);
for(int i=0; i<node_matrix.length; i++){
for(int j=0; j<node_matrix.length; j++){
System.out.print(node_matrix[i][j]+"  ");
}
System.out.println();
}
        //finding edge switches
            for(int j=0; j<node_matrix.length; j++)
                  if(node_matrix[Source_addr-1][j]!=0)es1=j;
            for(int j=0; j<node_matrix.length; j++)
                  if(node_matrix[Dest_addr-1][j]!=0)es2=j;
     }
     catch(Exception e){
             System.out.println("error in host finding "+srcnode+" "+dstnode);
              return false;
     }
        System.out.println(Source_addr+" : "+Dest_addr+" Edges("+es1+","+es2+") "+node_matrix.length);
       if(es1==-1 || es2==-1)return false;
        long calc_time=System.currentTimeMillis();
        int[][] dipath=FindDisjointPaths(node_matrix, es1,es2);
       calc_time=System.currentTimeMillis()-calc_time;
       boolean is_2path1=false,is_2path2=false;
       for(int i=0; i<dipath[0].length; i++)
           if(dipath[0][i]!=-1){is_2path1=true;break;}
       for(int i=0; i<dipath[1].length; i++)
           if(dipath[1][i]!=-1){is_2path2=true;break;}
       int c1=0,c2=0;
       for(int i=0; i<dipath[0].length; i++)
            if(dipath[0][i]!=-1){c1++;System.out.print(dipath[0][i]+"-->");}
       System.out.println();
       for(int i=0; i<dipath[1].length; i++)
             if(dipath[1][i]!=-1){c2++;System.out.print(dipath[1][i]+"-->");}
       System.out.println();
       if(is_2path1 && is_2path2)
       {
       int[] fp=new int[c1+1];
       int[] sp=new int[c2+1];
       for(int i=0; i<c1; i++)  fp[i]=dipath[0][i];
       for(int i=0; i<c2; i++)  sp[i]=dipath[1][i];
       fp[fp.length-1]=Dest_addr-1; //last AP
       sp[sp.length-1]=Dest_addr-1; //last AP
        System.out.print((Source_addr)+"->");
       for(int i=0; i<fp.length; i++)
         System.out.print((fp[i]+1)+"->");
       System.out.println(Is_validPath(fp));
         System.out.print((Source_addr)+"->");
       for(int i=0; i<sp.length; i++)
         System.out.print((sp[i]+1)+"->");
       System.out.println(Is_validPath(sp));
       //// the source node is adjusted here
         int init_node=-1,prime_node=-1,backup_node=-1;
         if(Is_validPath(fp) && Is_validPath(sp))
         {
           init_node=dipath[0][0]+1;
            prime_node=dipath[0][1]+1;
           backup_node=dipath[1][1]+1;
           System.out.println("prev_prime_cost="+Path_Cost(prev_paths[index])+" current prime_cost="+Path_Cost(fp));
           System.out.println("prev_second_cost="+Path_Cost(prev_paths[index+1])+" current second_cost="+Path_Cost(sp));
           if(Compare_Path(fp, prev_paths[index]))// this prime path is better than previous
                for(int i=0; i<fp.length; i++)
                      prev_paths[index][i]=fp[i];
           else{                                    // the previous prime is better than current path
                   int te=0;
               for(int i=0; i<prev_paths[index].length; i++)
                      if(prev_paths[index][i]!=-1)te++;
               fp=new int[te];
               for(int i=0; i<prev_paths[index].length; i++)
                   if(prev_paths[index][i]!=-1) fp[i]=prev_paths[index][i];
           }
           if(Compare_Path(sp, prev_paths[index+1]))// this second path is better than previous
                  for(int i=0; i<sp.length; i++)
                       prev_paths[index+1][i]=sp[i];
           else{                                     // the previous second is better than current path
               int te=0;
                for(int i=0; i<prev_paths[index+1].length; i++)
                    if(prev_paths[index+1][i]!=-1)te++;
             sp=new int[te];
             for(int i=0; i<prev_paths[index+1].length; i++)
                  if(prev_paths[index+1][i]!=-1) sp[i]=prev_paths[index+1][i];
           }
         res=true;
         Short BW = Short.valueOf((short) 0);
         Graph<Node, Edge> g = this.topologyBWAware.get(BW);
         List<Edge> path=(List<Edge>) new LinkedList<Edge>();
         int t=0;
         for (Edge s : g.getEdges()){
       //System.out.println(s);
       NodeConnector firstConnector = s.getHeadNodeConnector();
       NodeConnector tailConnector = s.getTailNodeConnector();
       Node n1 = firstConnector.getNode();
       Node n2 = tailConnector.getNode();
       long d1=(long)n1.getID();
       long d2=(long)n2.getID();
       int p=(int)d1;
       int q=(int)d2;
       if(p==init_node && q==prime_node)
       {
        Edge e = null;
        try {
         e = new Edge(firstConnector,tailConnector);
        } catch (ConstructionException e1) {
         // TODO Auto-generated catch block
         e1.printStackTrace();
        }
        path.add(t++, e);
       }
       if(p==init_node && q==backup_node)
       {
        Edge e = null;
        try {
         e = new Edge(firstConnector,tailConnector);
        } catch (ConstructionException e1) {
         // TODO Auto-generated catch block
         e1.printStackTrace();
        }
        path.add(t++, e);
       }
         }
         //System.out.println(clientAddr.toString()+"******"+dstAddr.toString()+" and "+iptohost.getAllHosts().size());
         // install for first AP
         Node tempnode=null;
         NodeConnector tempconn=null;
         byte prottype=17;//UDP
        for (Edge s : g.getEdges()){
       //System.out.println(s);
           NodeConnector firstConnector = s.getHeadNodeConnector();
           NodeConnector tailConnector = s.getTailNodeConnector();
           Node n1 = firstConnector.getNode();
           Node n2 = tailConnector.getNode();
           long d1=(long)n1.getID();
           long d2=(long)n2.getID();
           int p=(int)d1;
           int q=(int)d2;
           if(p==Source_addr && q==init_node)
             {
                   this.Insatll_Flows(prottype, startNode, startConnector, firstConnector,  clientAddr, dstAddr);
                   tempnode=n2;
                   tempconn=tailConnector;
                   System.out.println("Installed on first node");
             }
            }
        //Because SRLG produce two path, I should configure the first node (edge switch) to duplicate received traffic along two path
         NodeConnector firstConnector = path.get(0).getTailNodeConnector();
         NodeConnector firstConnector2=path.get(1).getTailNodeConnector();
         this.Insatll_Flows1(prottype, tempnode, tempconn, firstConnector,firstConnector2, clientAddr, dstAddr);
        ////the source node (edge switch) is adjusted above and below calls are for other nodes and paths
         manage_installation1(fp,fp.length,srcnode,dstnode);
         manage_installation1(sp,sp.length,srcnode,dstnode);
        }
         else if(Is_validPath(fp))
         {
         manage_installation2(fp,fp.length,srcnode,dstnode);
         }
         else
         manage_installation2(sp,sp.length,srcnode,dstnode);
        }
       else
       {
         System.out.println("DP CANNOT FIND SOLUTION");
         Dijkstras dij=new Dijkstras();
         dij.solve(node_matrix, Source_addr,Dest_addr);
         if(dij.pathlenght>1){
         for(int m=0; m<=dij.pathlenght; m++)
         System.out.print((dij.bestpath[m]+1)+"->");
         manage_installation2(dij.bestpath,dij.pathlenght+1,srcnode,dstnode);
         }
         else{System.out.println("Dij can't find solution");}
       }
       BufferedWriter output = null;
       try {
           File file = new File("calc_time.txt");
           output = new BufferedWriter(new FileWriter(file,true));
           output.append(Long.toString(calc_time)+"\n"); //convert to Mbps
       } catch ( IOException e ) {
           e.printStackTrace();
       } finally {
         if ( output != null ) {
          try {
               output.close();
            } catch (IOException e) {
                e.printStackTrace();
             }
         }
       }
return res;
}
public boolean Run_Route_SRLG(String srcnode,String dstnode,int[][] SharedLinkGraph,int ng, int index)
        {
             int Source_addr=0, Dest_addr=0;
             boolean res=false;
             NodeConnector startConnector=null;
             InetAddress clientAddr=null,dstAddr=null;
             Node startNode=null;
             int es1=-1,es2=-1;
             Send_Ether_Packet();
             Gather_Stat();
System.out.println(node_matrix.length);
             try{
                clientAddr = InetAddress.getByName(srcnode);//source node
                dstAddr = InetAddress.getByName(dstnode);//destination node
                HostNodeConnector startHostConnector = iptohost.hostFind(clientAddr);
                HostNodeConnector LastHostConnector = iptohost.hostFind(dstAddr);
                startConnector = startHostConnector.getnodeConnector();
                NodeConnector LastConnector = LastHostConnector.getnodeConnector();
                startNode = startConnector.getNode();
                Node lastNode = LastConnector.getNode();
                long d1=(long)startNode.getID();
                long d2=(long)lastNode.getID();
                Source_addr=(int)d1;
                Dest_addr=(int)d2;
System.out.println(node_matrix.length);
/*for(int i=0; i<node_matrix.length; i++){
for(int j=0; j<node_matrix.length; j++){
System.out.print(node_matrix[i][j]+"  ");
}
System.out.println();
}*/
                //finding edge switches
                    for(int j=0; j<node_matrix.length; j++)
                          if(node_matrix[Source_addr-1][j]!=0)es1=j;
                    for(int j=0; j<node_matrix.length; j++)
                          if(node_matrix[Dest_addr-1][j]!=0)es2=j;
             }
             catch(Exception e){
                     System.out.println("error in host finding "+srcnode+" "+dstnode);
                      return false;
             }
                System.out.println(Source_addr+" : "+Dest_addr+" Edges("+es1+","+es2+") "+node_matrix.length);
               if(es1==-1 || es2==-1)return false;
                long calc_time=System.currentTimeMillis();
               /*int[][]  SharedLinkGraph={//be careful:index begins from 0
               {0,6},{1,6},{6,7},{6,8},{2,5},{2,4},{5,4},{5,21},{8,7},{8,9},{11,14},{11,15},{18,11},{18,15},
               {20,19},{20,23},{7,12},{7,10}};*/
               SRLG srlg=new SRLG(node_matrix,SharedLinkGraph,es1+1,es2+1,2,ng);
               srlg.Solve();
               calc_time=System.currentTimeMillis()-calc_time;
               if(srlg.findpath)
               {
               int[] fp=new int[srlg.first_path_len+2];
               int[] sp=new int[srlg.second_path_len+2];
               for(int i=0; i<=srlg.first_path_len; i++)  fp[i]=srlg.first_path[i];
               for(int i=0; i<=srlg.second_path_len; i++)  sp[i]=srlg.second_path[i];
               fp[fp.length-1]=Dest_addr-1; //last AP
               sp[sp.length-1]=Dest_addr-1; //last AP
                System.out.print((Source_addr)+"->");
               for(int i=0; i<fp.length; i++)
                 System.out.print((fp[i]+1)+"->");
               System.out.println(Is_validPath(fp));
                 System.out.print((Source_addr)+"->");
               for(int i=0; i<sp.length; i++)
                 System.out.print((sp[i]+1)+"->");
               System.out.println(Is_validPath(sp));
               //// the source node is adjusted here
                 int init_node=-1,prime_node=-1,backup_node=-1;
                 if(Is_validPath(fp) && Is_validPath(sp))
                 {
                   init_node=srlg.first_path[0]+1;
                    prime_node=srlg.first_path[1]+1;
                   backup_node=srlg.second_path[1]+1;
                   System.out.println("prev_prime_cost="+Path_Cost(prev_paths[index])+" current prime_cost="+Path_Cost(fp));
                   System.out.println("prev_second_cost="+Path_Cost(prev_paths[index+1])+" current second_cost="+Path_Cost(sp));
                   if(Compare_Path(fp, prev_paths[index]))// this prime path is better than previous
                        for(int i=0; i<fp.length; i++)
                              prev_paths[index][i]=fp[i];
                   else{                                    // the previous prime is better than current path
                           int te=0;
                       for(int i=0; i<prev_paths[index].length; i++)
                              if(prev_paths[index][i]!=-1)te++;
                       fp=new int[te];
                       for(int i=0; i<prev_paths[index].length; i++)
                           if(prev_paths[index][i]!=-1) fp[i]=prev_paths[index][i];
                   }
                   if(Compare_Path(sp, prev_paths[index+1]))// this second path is better than previous
                          for(int i=0; i<sp.length; i++)
                               prev_paths[index+1][i]=sp[i];
                   else{                                     // the previous second is better than current path
                       int te=0;
                        for(int i=0; i<prev_paths[index+1].length; i++)
                            if(prev_paths[index+1][i]!=-1)te++;
                     sp=new int[te];
                     for(int i=0; i<prev_paths[index+1].length; i++)
                          if(prev_paths[index+1][i]!=-1) sp[i]=prev_paths[index+1][i];
                   }
                 res=true;
                 Short BW = Short.valueOf((short) 0);
                 Graph<Node, Edge> g = this.topologyBWAware.get(BW);
                 List<Edge> path=(List<Edge>) new LinkedList<Edge>();
                 int t=0;
                 for (Edge s : g.getEdges()){
               //System.out.println(s);
               NodeConnector firstConnector = s.getHeadNodeConnector();
               NodeConnector tailConnector = s.getTailNodeConnector();
               Node n1 = firstConnector.getNode();
               Node n2 = tailConnector.getNode();
               long d1=(long)n1.getID();
               long d2=(long)n2.getID();
               int p=(int)d1;
               int q=(int)d2;
               if(p==init_node && q==prime_node)
               {
                Edge e = null;
                try {
                 e = new Edge(firstConnector,tailConnector);
                } catch (ConstructionException e1) {
                 // TODO Auto-generated catch block
                 e1.printStackTrace();
                }
                path.add(t++, e);
               }
               if(p==init_node && q==backup_node)
               {
                Edge e = null;
                try {
                 e = new Edge(firstConnector,tailConnector);
                } catch (ConstructionException e1) {
                 // TODO Auto-generated catch block
                 e1.printStackTrace();
                }
                path.add(t++, e);
               }
                 }
                 //System.out.println(clientAddr.toString()+"******"+dstAddr.toString()+" and "+iptohost.getAllHosts().size());
                 // install for first AP
                 Node tempnode=null;
                 NodeConnector tempconn=null;
                 byte prottype=17;//UDP
                for (Edge s : g.getEdges()){
               //System.out.println(s);
                   NodeConnector firstConnector = s.getHeadNodeConnector();
                   NodeConnector tailConnector = s.getTailNodeConnector();
                   Node n1 = firstConnector.getNode();
                   Node n2 = tailConnector.getNode();
                   long d1=(long)n1.getID();
                   long d2=(long)n2.getID();
                   int p=(int)d1;
                   int q=(int)d2;
                   if(p==Source_addr && q==init_node)
                     {
                           this.Insatll_Flows(prottype, startNode, startConnector, firstConnector,  clientAddr, dstAddr);
                           tempnode=n2;
                           tempconn=tailConnector;
                           System.out.println("Installed on first node");
                     }
                    }
                //Because SRLG produce two path, I should configure the first node (edge switch) to duplicate received traffic along two path
                 NodeConnector firstConnector = path.get(0).getTailNodeConnector();
                 NodeConnector firstConnector2=path.get(1).getTailNodeConnector();
                 this.Insatll_Flows1(prottype, tempnode, tempconn, firstConnector,firstConnector2, clientAddr, dstAddr);
                ////the source node (edge switch) is adjusted above and below calls are for other nodes and paths
                 manage_installation1(fp,fp.length,srcnode,dstnode);
                 manage_installation1(sp,sp.length,srcnode,dstnode);
                }
                 else if(Is_validPath(fp))
                 {
                 manage_installation2(fp,fp.length,srcnode,dstnode);
                 }
                 else
                 manage_installation2(sp,sp.length,srcnode,dstnode);
                }
               else
               {
                 System.out.println("SRLG CANNOT FIND SOLUTION");
                 Dijkstras dij=new Dijkstras();
                 dij.solve(node_matrix, Source_addr,Dest_addr);
                 if(dij.pathlenght>1){
                 for(int m=0; m<=dij.pathlenght; m++)
                 System.out.print((dij.bestpath[m]+1)+"->");
                 manage_installation2(dij.bestpath,dij.pathlenght+1,srcnode,dstnode);
                 }
                 else{System.out.println("Dij can't find solution");}
               }
               BufferedWriter output = null;
               try {
                   File file = new File("calc_time.txt");
                   output = new BufferedWriter(new FileWriter(file,true));
                   output.append(Long.toString(calc_time)+"\n"); //convert to Mbps
               } catch ( IOException e ) {
                   e.printStackTrace();
               } finally {
                 if ( output != null ) {
                  try {
                       output.close();
                    } catch (IOException e) {
                        e.printStackTrace();
                     }
                 }
               }
        return res;
        }
public void Gather_Stat()
{
       Short baseBW = Short.valueOf((short) 0);
       Graph<Node, Edge> g = this.topologyBWAware.get(baseBW);
 String containerName = "default";
ISwitchManager switchManager = (ISwitchManager) ServiceHelper.getInstance(ISwitchManager.class, containerName, this);
node_matrix=new double[switchManager.getNodes().size()][switchManager.getNodes().size()];
for(int i=0; i<node_matrix.length; i++)
for(int j=0; j<node_matrix.length; j++)
     node_matrix[i][j]=0;
long d1=0,d2=0,transmit1=0,transmit2=0;
for (Edge s : g.getEdges()){
    NodeConnector firstConnector = s.getHeadNodeConnector();
    NodeConnector tailConnector = s.getTailNodeConnector();
     Node n1 = firstConnector.getNode();
    Node n2 = tailConnector.getNode();
    transmit1=readService.getTransmitRate(firstConnector)/1000000;//Mbps
    d1=(long)n1.getID();
    transmit2=readService.getTransmitRate(tailConnector )/1000000;//Mbps
    d2=(long)n2.getID();
   int p=(int)d1;
  int q=(int)d2;
  double x=(double)(((transmit1)+(transmit2))/2);
  double alpha=0.5;
  double wifi=100,wired=80;
  if(p==q)node_matrix[p-1][q-1]=0;
   else
   {
      if(is_link(p, q)) ///wireless link
             node_matrix[p-1][q-1]=wifi*(alpha*(x+10)+(1-alpha)*(double)delay_matrix[p-1][q-1]);   //x+10 (for prohibiting zero values for utilization)
      else //wired link
          node_matrix[p-1][q-1]=wired*(alpha*(x+10)+(1-alpha)*(double)delay_matrix[p-1][q-1]);   //x+10 (for prohibiting zero values for utilization)
   }
}
/*for(int i=0; i<node_matrix.length; i++){
for(int j=0; j<node_matrix.length; j++){
System.out.print(node_matrix[i][j]+"  ");
}
System.out.println();
}*/
}

public int Path_Delay(int[] a,int l_index)
{
    int total_delay=0;
   for(int i=0; i<l_index; i++)
      total_delay+=delay_matrix[a[i]][a[i+1]];
   return total_delay;
}

public int Path_Cost(int[] a)
{
    int total_cost=0;
    System.out.println(a.length);
    boolean flag=false;
    for(int i=0; i<a.length; i++)
         if(a[i]!=-1)flag=true;
    if(!flag)return Integer.MAX_VALUE;
   for(int i=0; i<a.length-1; i++)
        if(a[i]==-1 ||a[i+1]==-1  ) break;
        else
               total_cost+=node_matrix[a[i]][a[i+1]];
   return total_cost;
}
public boolean Is_validPath(int[] path)
{
    boolean res=false;
    Short BW = Short.valueOf((short) 0);
    Graph<Node, Edge> g = this.topologyBWAware.get(BW);
    for(int t=0; t<path.length-1; t++){
     res=false;
    for (Edge s : g.getEdges()){
     //System.out.println(s);
     NodeConnector firstConnector = s.getHeadNodeConnector();
     NodeConnector tailConnector = s.getTailNodeConnector();
     Node n1 = firstConnector.getNode();
     Node n2 = tailConnector.getNode();
     long d1=(long)n1.getID();
     long d2=(long)n2.getID();
     int p=(int)d1;
     int q=(int)d2;
     if((p==(path[t]+1) && q==(path[t+1]+1))||(q==(path[t]+1) && p==(path[t+1]+1))){
     res=true;}
    }
    if(!res){/*System.out.println("*"+path[t]+"->"+path[t+1]+"  "+path.length);*/break;}
    }
    return res;
}
public void manage_installation1(int[] inpath,int len,String src,String dst)
{
    List<Edge> path=Convert_to_Path(inpath,len);
    int edges = path.size();
      for(int i = 0;i<edges;i++){
       try{
     byte prottype=17;//UDP
     InetAddress clientAddr = InetAddress.getByName(src);//source node
     InetAddress dstAddr = InetAddress.getByName(dst);//destination node
     //System.out.println(clientAddr.toString()+"******"+dstAddr.toString()+" and "+iptohost.getAllHosts().size());
       HostNodeConnector endHostConnector = iptohost.hostFind(dstAddr);
       NodeConnector endConnector = endHostConnector.getnodeConnector();
       // The node, source and destination ("switch")
       Node endNode = endConnector.getNode();
      if(i==0)
      {
// the source node has been adjusted in above
      }
      else
      {
       NodeConnector tailConnector = path.get(i).getTailNodeConnector();
       NodeConnector headConnector = path.get(i-1).getHeadNodeConnector();
       Node passingNode = tailConnector.getNode();
       this.Insatll_Flows(prottype, passingNode, headConnector, tailConnector,  clientAddr, dstAddr);
       if(i==edges-1)
       {
     NodeConnector lastConnector = path.get(i).getHeadNodeConnector();
     this.Insatll_Flows(prottype, endNode, lastConnector, endConnector, clientAddr, dstAddr);
       }
      }
       }
       catch(Exception e){
     log.error(e.getMessage());
       }
      }
}
public void manage_installation2(int[] inpath,int len,String src,String dst)
{
    List<Edge> path=Convert_to_Path(inpath,len);
    int edges = path.size();
      for(int i = 0;i<edges;i++){
       try{
     byte prottype=17;//UDP
     InetAddress clientAddr = InetAddress.getByName(src);//source node
     InetAddress dstAddr = InetAddress.getByName(dst);//destination node
     //System.out.println(clientAddr.toString()+"******"+dstAddr.toString()+" and "+iptohost.getAllHosts().size());
       HostNodeConnector startHostConnector = iptohost.hostFind(clientAddr);
       HostNodeConnector endHostConnector = iptohost.hostFind(dstAddr);
       NodeConnector startConnector = startHostConnector.getnodeConnector();
       NodeConnector endConnector = endHostConnector.getnodeConnector();
       // The node, source and destination ("switch")
       Node startNode = startConnector.getNode();
       Node endNode = endConnector.getNode();
      if(i==0)
      {
      NodeConnector firstConnector = path.get(i).getTailNodeConnector();
       this.Insatll_Flows(prottype, startNode, startConnector, firstConnector,  clientAddr, dstAddr);
      }
      else
      {
       NodeConnector tailConnector = path.get(i).getTailNodeConnector();
       NodeConnector headConnector = path.get(i-1).getHeadNodeConnector();
       Node passingNode = tailConnector.getNode();
       this.Insatll_Flows(prottype, passingNode, headConnector, tailConnector, clientAddr, dstAddr);
       if(i==edges-1)
       {
     NodeConnector lastConnector = path.get(i).getHeadNodeConnector();
     this.Insatll_Flows(prottype, endNode, lastConnector, endConnector,  clientAddr, dstAddr);
       }
      }
       }
       catch(Exception e){
     log.error(e.getMessage());
       }
      }
}
public void Send_Ether_Packet()
{
      byte[] srcMAC= {0,0,0,0,0,0x00};
      byte[] dstMAC= {0,0,0,0,0,0x00};
     Short baseBW = Short.valueOf((short) 0);
     // Initialize mtp also using the default topo
     Graph<Node, Edge> g = this.topologyBWAware.get(baseBW);
     for (Edge s : g.getEdges()){
      NodeConnector firstConnector = s.getHeadNodeConnector();
      NodeConnector tailConnector = s.getTailNodeConnector();
       Node n1 = firstConnector.getNode();
      Node n2 = tailConnector.getNode();
      Ethernet ethernet = new Ethernet();
      short type=0xfc;//I use this value for creating unique l2 packet
      long r=(long)firstConnector.getNode().getID();
      long d=(long)tailConnector.getNode().getID();
      srcMAC[5]=(byte)r;//source
      dstMAC[5]=(byte)d;//destination
      ethernet.setSourceMACAddress(srcMAC).setDestinationMACAddress(dstMAC).setEtherType(type);
      Date date = new Date();
      long stamp=(long)date.getTime();
       byte[] timestamp=longToBytes(stamp);
       ethernet.setRawPayload(timestamp);
       RawPacket destPkt = this.dataPacketService.encodeDataPacket(ethernet);
       destPkt.setOutgoingNodeConnector(firstConnector);
      // System.out.println("size is="+ss.length+" and "+bytesToLong(ss));
      // System.out.println("Packet from "+firstConnector.toString()+" to "+tailConnector.toString()+" in time" +System.currentTimeMillis());
       this.dataPacketService.transmitDataPacket(destPkt);
}

}
public byte[] longToBytes(long x) {
    ByteBuffer buffer = ByteBuffer.allocate(Long.SIZE);
    buffer.putLong(x);
    return buffer.array();
}
public long bytesToLong(byte[] bytes) {
     ByteBuffer buffer = ByteBuffer.allocate(Long.SIZE);
    buffer.put(bytes);
    buffer.flip();//need flip
    return buffer.getLong();
}

     // TODO Auto-generated method stub
public List<Edge> Convert_to_Path(int[] p_mat,int p_len)
{
      Short BW = Short.valueOf((short) 0);
      Graph<Node, Edge> g = this.topologyBWAware.get(BW);
      List<Edge> path=(List<Edge>) new LinkedList<Edge>();
      int t=0;
      try
      {
      for(int i=0;i<p_len-1;i++)
      {
      int head=p_mat[i]+1;//because the index of nodes in matrix is supposed to begin from 0 I add +1
     // System.out.println(head+"   "+(p_mat[i+1]+1));
      int tail=p_mat[i+1]+1;//because the index of nodes in matrix is supposed to begin from 0 I add +1
      for (Edge s : g.getEdges()){
       NodeConnector firstConnector = s.getHeadNodeConnector();
       NodeConnector tailConnector = s.getTailNodeConnector();
       Node n1 = firstConnector.getNode();
       Node n2 = tailConnector.getNode();
       long d1=(long)n1.getID();
       long d2=(long)n2.getID();
       int p=(int)d1;
       int q=(int)d2;
       if(p==head && q==tail)
       {
     Edge e=new Edge(firstConnector,tailConnector);
     path.add(t++, e);
     System.out.println(e);
       }
      }
      }
      }
      catch(ConstructionException e)
      {
       log.error(e.getMessage());
      }
return path;
 }
public void Insatll_Flows( Node switchnode, NodeConnector input, NodeConnector output, InetAddress srcAddr, InetAddress dstAddr)
{
       Match match = new Match();
       match.setField(MatchType.DL_TYPE, (short) 0x0800); // IPv4
       //match.setField(MatchType.NW_PROTO,type);
       match.setField(MatchType.IN_PORT, input);
       match.setField(MatchType.NW_SRC, srcAddr);
       match.setField(MatchType.NW_DST, dstAddr);
       List<Action> actions = new LinkedList<Action>(); // List of actions applied to the packet
       actions.add(new Output(output)); // Output packet on port to server instance
       Flow flow = new Flow(match, actions); // Create the flow
       //flow.setIdleTimeout((short) 20);
       flow.setHardTimeout((short) 0);
       flow.setPriority((short)1);
       Status status1 = flowProgrammerService.addFlow(switchnode, flow); // Use FlowProgrammerService to program flow.
       if (status1.isSuccess()) {
      //  System.out.println("The Flow has been installed on node"+switchnode.getID().toString());
      }
}
public void Insatll_Flows1(byte type, Node switchnode, NodeConnector input, NodeConnector output, NodeConnector output2,  InetAddress srcAddr, InetAddress dstAddr)
{
       Match match = new Match();
       match.setField(MatchType.DL_TYPE, (short) 0x0800); // IPv4
       match.setField(MatchType.NW_PROTO,type);
       match.setField(MatchType.IN_PORT, input);
       match.setField(MatchType.NW_SRC, srcAddr);
       match.setField(MatchType.NW_DST, dstAddr);
       List<Action> actions = new LinkedList<Action>(); // List of actions applied to the packet
       actions.add(new Output(output)); // Output packet on port to server instance
       actions.add(new Output(output2));
       Flow flow = new Flow(match, actions); // Create the flow
       //flow.setIdleTimeout((short) 20);
       flow.setPriority((short)255);
       Status status1 = flowProgrammerService.addFlow(switchnode, flow); // Use FlowProgrammerService to program flow.
       //Status status1=this.frm.installFlowEntry(po);
       if (status1.isSuccess()) {
     //System.out.println("The Flow has been installed on node"+switchnode.getID().toString());
      }

}
public void Insatll_Flows(byte type, Node switchnode, NodeConnector input, NodeConnector output, InetAddress srcAddr, InetAddress dstAddr)
{
       Match match = new Match();
       match.setField(MatchType.DL_TYPE, (short) 0x0800); // IPv4
       match.setField(MatchType.NW_PROTO,type);
       match.setField(MatchType.IN_PORT, input);
       match.setField(MatchType.NW_SRC, srcAddr);
       match.setField(MatchType.NW_DST, dstAddr);
       List<Action> actions = new LinkedList<Action>(); // List of actions applied to the packet
       actions.add(new Output(output)); // Output packet on port to server instance
       Flow flow = new Flow(match, actions); // Create the flow
       flow.setPriority((short)255);
       Status status1 = flowProgrammerService.addFlow(switchnode, flow); // Use FlowProgrammerService to program flow.
       //Status status1=this.frm.installFlowEntry(po);
       if (status1.isSuccess()) {
     //System.out.println("The Flow has been installed on node"+switchnode.getID().toString());
      }

}

public void Append_To_File(String Value,String FileName)
{
            BufferedWriter output = null;
            try {
                File file = new File(FileName);
                output = new BufferedWriter(new FileWriter(file,true));
                output.append(Value+"\n");
            } catch ( IOException e ) {
                e.printStackTrace();
            } finally {
              if ( output != null ) {
               try {
                    output.close();
                 } catch (IOException e) {
                     e.printStackTrace();
                  }
              }
            }
}
public void Write_To_File(String Value,String FileName)
{
            BufferedWriter output = null;
            try {
                File file = new File(FileName);
                output = new BufferedWriter(new FileWriter(file,true));
                output.write(Value+"\n");
            } catch ( IOException e ) {
                e.printStackTrace();
            } finally {
              if ( output != null ) {
               try {
                    output.close();
                 } catch (IOException e) {
                     e.printStackTrace();
                  }
              }
            }
}
public void Check_Hosts_Failure()
{
    Set<HostNodeConnector> M=iptohost.getAllHosts();
    Iterator<HostNodeConnector> itr1 = M.iterator();
    HostNodeConnector itr2 ;//= M.iterator();
    int k=0 ;
    String containerName = "default";
    IStatisticsManager statsManager = (IStatisticsManager) ServiceHelper.getInstance(IStatisticsManager.class, containerName, this);
    while (k<M.size()){
           itr2=itr1.next();
           List<NodeConnectorStatistics> stats1 = statsManager.getNodeConnectorStatistics(itr2.getnodeConnector().getNode());
           NodeConnectorStatistics ns1 = stats1.get(Integer.parseInt(itr2.getnodeConnector().getID().toString()));
           for(int i=0; i<HostsTrack.length;i++)
                if(HostsTrack[i][0].trim().contains(itr2.getNetworkAddress().getHostName().trim()))
                {
                           long rb=Long.valueOf(HostsTrack[i][1].trim());
                           long rn=Long.valueOf(ns1.getReceivePacketCount())+Long.valueOf(ns1.getTransmitPacketCount());
                           Date d=new Date();
                           if(rb==rn)
                           {
                              String str="Host "+HostsTrack[i][0].trim()+" Does not Exist in the Network Anymore at "+d.getTime();
                              System.out.println(str);
                              Append_To_File(str, "HostFailLogFile.txt");
                           }
                           HostsTrack[i][1]=Long.toString(rn);
                }
           k++;
       }

for(int i=0; i<HostsTrack.length;i++)
              System.out.println(HostsTrack[i][0].trim()+" "+HostsTrack[i][1].trim());
}
public void Switch_to_Host_Stats_Gathering()
{
    Set<HostNodeConnector> M=iptohost.getAllHosts();
    Iterator<HostNodeConnector> itr1 = M.iterator();
    HostNodeConnector itr2 ;//= M.iterator();
    int k=0 ;
    String containerName = "default";
    IStatisticsManager statsManager = (IStatisticsManager) ServiceHelper.getInstance(IStatisticsManager.class, containerName, this);

    while (k<M.size()){
           itr2=itr1.next();
           List<NodeConnectorStatistics> stats1 = statsManager.getNodeConnectorStatistics(itr2.getnodeConnector().getNode());
           NodeConnectorStatistics ns1 = stats1.get(Integer.parseInt(itr2.getnodeConnector().getID().toString()));
           HostsTrack[k][0]=itr2.getNetworkAddress().getHostName().trim();
           HostsTrack[k][1]=String.valueOf(0);
           k++;
       }
/*
     k=0;
     itr1 = M.iterator();
    while (k<M.size()){
           itr2=itr1.next();
           List<NodeConnectorStatistics> stats1 = statsManager.getNodeConnectorStatistics(itr2.getnodeConnector().getNode());
           NodeConnectorStatistics ns1 = stats1.get(Integer.parseInt(itr2.getnodeConnector().getID().toString()));
           for(int i=0; i<M.size();i++)
                if(HostsTrack[i][0].trim().contains(itr2.getNetworkAddress().getHostName().trim()))
                      HostsTrack[i][1]=String.valueOf(ns1.getReceivePacketCount()+ns1.getTransmitPacketCount());
           k++;
       }*/
}
public void Default_Routing_For_Hosts()
{
 Set<HostNodeConnector> M=iptohost.getAllHosts();
 Iterator<HostNodeConnector> itr1 = M.iterator();
 HostNodeConnector itr2 ;//= M.iterator();
 InetAddress[] hosts=new InetAddress[M.size()];
 Node[] nodes=new Node[M.size()];
 if(M.size()>0)first_time=true;//only once
 int k=0;
 while (k<M.size()){
        itr2=itr1.next();
        hosts[k]=itr2.getNetworkAddress();
        nodes[k]=itr2.getnodeConnector().getNode();
        k++;
    }
 int j=0,p=0;
while (p< k)
{
     j=0;
     while (j<k)
     {
         InetAddress source=hosts[j] , dest=hosts[p];
         Node node1=nodes[j],node2=nodes[p];
         if(!source.equals(dest) && !node1.equals(node2))
         {
                  Path path=getRoute(node1,node2);
                  if(path!=null){
                       int edges = path.getEdges().size();
                       //System.out.println("Number of Edges= "+edges);
                       /*System.out.println();
                       for(int i = 0;i<edges;i++){
                           System.out.print(path.getEdges().get(i)+"==>");
                            }*/
                       for(int i = 0;i<edges;i++){
                       HostNodeConnector startHostConnector = iptohost.hostFind(source);
                       HostNodeConnector endHostConnector = iptohost.hostFind(dest);
                       NodeConnector startConnector = startHostConnector.getnodeConnector();
                       NodeConnector endConnector = endHostConnector.getnodeConnector();
                       // The node, source and destination ("switch")
                       Node startNode = startConnector.getNode();
                       Node endNode = endConnector.getNode();
                       if(i==0 && edges == 1)
                       {
                       NodeConnector firstConnector = path.getEdges().get(i).getTailNodeConnector();
                       this.Insatll_Flows(startNode, startConnector, firstConnector, source,dest);
                       NodeConnector lastConnector = path.getEdges().get(i).getHeadNodeConnector();
                       this.Insatll_Flows(endNode, lastConnector, endConnector, source, dest);
                       //System.out.println("Number 1");
                       }
                       else if(i==0 && edges > 1)
                       {
                       NodeConnector firstConnector = path.getEdges().get(i).getTailNodeConnector();
                       this.Insatll_Flows(startNode, startConnector, firstConnector, source,dest);
                      // System.out.println("Number 2");
                       }
                       else
                       {
                       NodeConnector tailConnector = path.getEdges().get(i).getTailNodeConnector();
                       NodeConnector headConnector = path.getEdges().get(i-1).getHeadNodeConnector();
                       Node passingNode = tailConnector.getNode();
                       this.Insatll_Flows( passingNode, headConnector, tailConnector, source,dest);
                       //System.out.println("Number 3");
                       if(i==edges-1)
                       {
                       NodeConnector lastConnector = path.getEdges().get(i).getHeadNodeConnector();
                       this.Insatll_Flows( endNode, lastConnector, endConnector, source,dest);
                      // System.out.println("Number 4");
                       }
                       }
                       }
                       //System.out.println("new rules have been installed for source "+source.toString()+" to destination "+dest.toString());
                       }
         }
         else if(!source.equals(dest) && node1.equals(node2))  // two hosts are connected to the same node
         {
                 HostNodeConnector startHostConnector = iptohost.hostFind(source);
                 HostNodeConnector endHostConnector = iptohost.hostFind(dest);
                 NodeConnector startConnector = startHostConnector.getnodeConnector();
                 NodeConnector endConnector = endHostConnector.getnodeConnector();
                 Node startNode = startConnector.getNode();
                 this.Insatll_Flows( startNode, startConnector, endConnector, source, dest);
         }
         j++;
       }
     p++;
  }
}

public void Show_AllPaths(List<Yen_K_Path.Path> shortest_paths_list)
{
   // System.out.println("Paths:"+shortest_paths_list);
   // System.out.println(shortest_paths_list.size());
    String res="";
    System.out.println("*************"+shortest_paths_list.size()+"*********************");
    for(int i=0; i<shortest_paths_list.size(); i++)
    {
        res=shortest_paths_list.get(i).toString().substring(shortest_paths_list.get(i).toString().indexOf("[")+1,shortest_paths_list.get(i).toString().indexOf("]"));
        String[] array = res.split(",");
        for(int j=0; j<array.length; j++)
            System.out.print((Integer.parseInt(array[j].trim()) %node_matrix.length )+"->");
        System.out.println();
       int[] path=getpath(shortest_paths_list.get(i).toString().substring(shortest_paths_list.get(i).toString().indexOf("[")+1,shortest_paths_list.get(i).toString().indexOf("]")));
       // System.out.println("  The Cost is="+Path_Cost(path));
    }
}
public int[][] FindDisjointPaths(double[][] g,int src,int dst) throws UnknownHostException
{
        List<Yen_K_Path.Path> shortest_paths_list=Find_Kpath(g,src,dst);
        Show_AllPaths( shortest_paths_list);
        int[] path1=null;
        int[] path2=null;
        int[][] Ret=null;
        boolean find=true;
        if(shortest_paths_list.size()>0)
        {
                    path1=getpath(shortest_paths_list.get(0).toString().substring(shortest_paths_list.get(0).toString().indexOf("[")+1,shortest_paths_list.get(0).toString().indexOf("]")));
                    if(shortest_paths_list.size()>1)
                    {
                            for(int k=1; k<shortest_paths_list.size();k++)
                            {
                               path2=getpath(shortest_paths_list.get(k).toString().substring(shortest_paths_list.get(k).toString().indexOf("[")+1,shortest_paths_list.get(k).toString().indexOf("]")));
                               //check disjointness
                               find=true;
                               for(int i=0; i<path1.length-1; i++)
                               {
                                       for(int j=0;j<path2.length-1;j++)
                                               if(path1[i]==path2[j] && path1[i+1]==path2[j+1]){find=false; break;}
                                       if(find==false)break;
                               }
                               if(find)
                               {
                                       int max_len=0;
                                       if(path1.length>path2.length)max_len=path1.length;else max_len=path2.length;
                                       Ret=new int[2][max_len];
                                       for(int i=0; i<max_len;i++)
                                       {
                                               Ret[0][i]=-1;
                                           Ret[1][i]=-1;
                                    }
                                       for(int i=0; i<path1.length;i++)
                                               Ret[0][i]=path1[i];
                                       for(int i=0; i<path2.length;i++)
                                               Ret[1][i]=path2[i];
                                       break;
                               }
                               else
                               {
                                      Ret=new int[2][path1.length];
                                      for(int i=0; i<path1.length;i++)
                                      {
                                              Ret[0][i]=-1;
                                          Ret[1][i]=-1;
                                        }
                                      for(int i=0; i<path1.length;i++)
                                          Ret[0][i]=path1[i];
                               }
                               //System.out.println(find);
                            }
                    }
        }
        return Ret;
}
public int[] getpath(String res)
{
        int[] path=null;
        String[] array = res.split(",");
    path=new int[array.length];
    for(int j=0; j<array.length; j++)
        path[j]=Integer.parseInt(array[j].trim()) % node_matrix.length;
    return path;
}
public List<Yen_K_Path.Path> Find_Kpath(double[][] mat,int s, int t) throws UnknownHostException
{
/*
 * Very Important Note: there is a small problem when we are using Yen package.
 * the problem is related to the command "graph._vertex_list.add(vertex);"
 * in this command when you call it for adding vertex, it assigns the number of
 * vertex incrementally. for example if you have 5 vertex, in the first call of
 * this command the number of vertexes are 0 to 4. in the next call the number of
 * vertexes will be 5 to 9. in the third call the numbers will be 11 to 14 and so on.
 * for eliminating the problem rises from this problem, I consider a variable "COUNT"
 * By using this variable, we can call this method multiple time.
 * */
    int src=s,dst=t;
    double a=0.5;
   // System.out.println("Testing batch processing of top-k shortest paths!1");
    Yen_K_Path.Graph graph=new Yen_K_Path.Graph();
    graph.set_vertex_num(mat.length);
    System.out.println(mat.length+"  "+graph.get_vertex_list());
    for(int i=0; i<graph._vertex_num; ++i)
    {
          BaseVertex vertex = new Vertex();
          graph._vertex_list.add(vertex);
          COUNT++;
          graph._id_vertex_index.put(vertex.get_id(), vertex);
    }
    System.out.println(mat.length+"  "+graph.get_vertex_list());

    System.out.println(COUNT);
    for(int i=COUNT; i<COUNT+mat.length; i++)
        for(int j=COUNT; j<COUNT+mat.length; j++)
            if(i!=j && mat[i%mat.length][j%mat.length]!=0){
            graph.add_edge(i, j, mat[i%mat.length][i%mat.length]);}
  //  System.out.println("Testing batch processing of top-k shortest paths!3");
    Yen_K_Path.YenTopKShortestPathsAlg yenAlg = new Yen_K_Path.YenTopKShortestPathsAlg(graph);
    int K=20;
    List<Yen_K_Path.Path> shortest_paths_list = yenAlg.get_shortest_paths(graph.get_vertex(src+COUNT), graph.get_vertex(dst+COUNT), K);
    //System.out.println("Paths:"+shortest_paths_list);
   /* System.out.println(yenAlg.get_result_list().size());
    String res="";
    System.out.println("*************"+shortest_paths_list.size()+"*********************");
    for(int i=0; i<shortest_paths_list.size(); i++)
    {
        res=shortest_paths_list.get(i).toString().substring(shortest_paths_list.get(i).toString().indexOf("[")+1,shortest_paths_list.get(i).toString().indexOf("]"));
        String[] array = res.split(",");
        for(int j=0; j<array.length; j++)
            System.out.print((Integer.parseInt(array[j].trim()) %mat.length )+"->");
        System.out.println();
    }*/
   return shortest_paths_list;
}
}
