#!/usr/bin/python

from mininet.net import Mininet
from mininet.node import Controller, RemoteController, OVSKernelSwitch, IVSSwitch, UserSwitch
from mininet.link import Link, TCLink
from mininet.cli import CLI
from mininet.log import setLogLevel
from time import sleep
from string import Template
import os.path
from os import path
import random
import datetime
import time
import sys
import os

def check():
    if path.exists('/home/rezmo/opendaylight/ACK.txt'):
	    with open('/home/rezmo/opendaylight/ACK.txt') as f:
		datafile = f.readlines()
	    found = False  
	    for line in datafile:
		if "OK" in line:
		    return True
    return False  

def topology():

        "Create a network."
        net = Mininet( controller=Controller, link=TCLink, switch=OVSKernelSwitch )

        print "*** Creating nodes (Switches)"
        s1 = net.addSwitch( 's1', listenPort=6673, mac='00:00:00:00:00:01')
        s2 = net.addSwitch( 's2', listenPort=6674, mac='00:00:00:00:00:02' )
        s3 = net.addSwitch( 's3', listenPort=6675, mac='00:00:00:00:00:03'  )
        s4 = net.addBaseStation( 's4', ssid="MY_SSID", mode="g", channel="11"   )
        s5 = net.addBaseStation( 's5',  ssid="MY_SSID", mode="g", channel="1"  )

	
	print "*** Creating APs"
	
        AP1 = net.addBaseStation( 's6', ssid="MY_SSID", mode="g", channel="1" )
        AP2 = net.addBaseStation( 's7', ssid="MY_SSID", mode="g", channel="11" )
        AP3 = net.addBaseStation( 's8', ssid="MY_SSID", mode="g", channel="6" )
	
	print "*** Creating Hosts"

        h1 = net.addStation( 'h1')
        h2 = net.addStation( 'h2')
        h3 = net.addStation( 'h3')
        h4 = net.addStation( 'h4')
        h5 = net.addStation( 'h5')
        h6 = net.addStation( 'h6')

        c1 = net.addController( 'c1', controller=RemoteController, ip='127.0.0.1', port=6633 )

        print "*** Creating links between Switches"
        net.addLink(s1, s2,1,1,delay='10ms')
        net.addLink(s5, s1,delay='10ms')
        net.addLink(s1, s3,3,1,delay='10ms')
        net.addLink(s2, s3,delay='10ms')
        net.addLink(s4, s3,delay='10ms')
        net.addLink(s5, s4,delay='10ms')


	print "*** Creating links between Switches and APs"
	net.addLink(AP1, s5,delay='10ms')
	#net.addLink(AP1, s5,delay='10ms')
	net.addLink(AP2, s3,delay='10ms')
	#net.addLink(AP2, s3,delay='10ms')
	net.addLink(AP3, s3,delay='10ms')
	#net.addLink(AP3, s3,delay='10ms')


	print "*** Creating links between Hosts and APs"
	net.addLink(AP1, h1)
	net.addLink(AP1, h2)
	net.addLink(AP2, h3)
	net.addLink(AP2, h4)
	net.addLink(AP3, h5)
	net.addLink(AP3, h6)
 
        print "*** Starting network"
        net.build()
        c1.start()
        s4.start( [c1] )
        s5.start( [c1] )
        s3.start( [c1] )
        s2.start( [c1] )
        s1.start( [c1] ) 
        AP1.start( [c1] ) 
        AP2.start( [c1] ) 
        AP3.start( [c1] ) 

        # below loop is used to inform the controller about all hosts before loading the module
        for w in net.hosts:
           h1.cmd('ping -c 1 -W 1 %s ' % w.IP())
        #cmd = 'cp routing.MY_TE_TECH-0.4.1-SNAPSHOT.jar /home/rezmo/opendaylight/plugins/routing.MY_TE_TECH-0.4.1-SNAPSHOT.jar'
        #os.system(cmd)
        #remove Previous STOP Command
        cmd="rm -f /home/rezmo/opendaylight/ACK.txt"
        os.system(cmd)
        cmd="sed '/STOP/d' /home/rezmo/opendaylight/Inputs.txt  > temp.txt"
        os.system(cmd)
        cmd="cat temp.txt > /home/rezmo/opendaylight/Inputs.txt"
        os.system(cmd)
        cmd="sed '/START/d' /home/rezmo/opendaylight/Inputs.txt  > temp.txt"
        os.system(cmd)
        cmd="cat temp.txt > /home/rezmo/opendaylight/Inputs.txt"
        os.system(cmd)
        cmd = "echo \"START\" >> /home/rezmo/opendaylight/Inputs.txt"
        os.system(cmd)
        sleep(5)
        if "Normal" in str(sys.argv[5]):
		cmd = "echo \"OK\" >> /home/rezmo/opendaylight/ACK.txt"
		os.system(cmd)
        
        #wait till the controller installs a path 
        while True:
            ret=check()
            print "Be Patinet till the controller installs the paths!!"
            if ret==True:
               break
        #input ('enter a key to start=')
        print "Traffic sending is beggining!"
        # below loop is used to Set Energy and tx/rx power for the hosts
        for w in net.hosts:
           h1.cmd('python ./IoTDeviceMain.py '+str(w)+' 2 1 100 &')

           
        h2.cmd("java UDP_SERVER_UNI 2 10001 10.0.0.5 > SERVER_SENDING2.log &")
        h5.cmd("java UDP_Client_UNI 10001  >> result2.txt &")           
        h3.cmd("java UDP_SERVER_UNI 2 20002 10.0.0.1 > SERVER_SENDING3.log &")
        h1.cmd("java UDP_Client_UNI  20002  >> result3.txt &")                
        h6.cmd("java UDP_SERVER_UNI 2 20002 10.0.0.2 > SERVER_SENDING4.log &")
        h2.cmd("java UDP_Client_UNI 20002  >> result4.txt &") 
        #h4.cmd("java UDP_SERVER_UNI 2 10001 10.0.0.1 > SERVER_SENDING1.log &")
        #h1.cmd("java UDP_Client_UNI  10001  >> result1.txt &")       

        abort_after =int(sys.argv[1]) 
        fail_time=int(sys.argv[3])*2
        fail_interval=int(sys.argv[2])
        #shared Links	
        fail_item1 = ["sudo ip link set s1-eth1 down","sudo ip link set s2-eth1 down"]
        fail_item2 = ["sudo ip link set s1-eth3 down","sudo ip link set s3-eth1 down"]

        fail_flag=0
        start = time.time()
        temp1=time.time()
        temp2=0
        temp_time=time.time()
        while True:
                resultta = time.time() - start
	        if resultta >= abort_after:
	               break
		
		temp_fail=time.time() - temp_time
		if temp_fail >= fail_interval:
                     if fail_flag==0:
		        temp_time=time.time()
                   	print "All links DOWN at" +str(time.time())
		        r1=random.choice(fail_item1)
		        r2=random.choice(fail_item2)
		        temp1=time.time()
		        os.system(r1)
		        os.system(r2)
		        fail_flag=1
			
	        temp2=time.time() - temp1
		if temp2 >= fail_time and fail_flag==1:
                        print str(temp_fail) +"   "+str(time.time())
			fail_flag=0
			print "All links UP at" +str(time.time())
			os.system("sudo ip link set s1-eth1 up")
			os.system("sudo ip link set s1-eth3 up")
			os.system("sudo ip link set s2-eth1 up")
			os.system("sudo ip link set s3-eth1 up")

        #CLI( net )
        for i in range(2,5):
		cmd = 'mv result'+str(i)+'.txt results/'+str(sys.argv[5])+'/rec_result_'+str(i)+'_'+str(sys.argv[4])+'_'+str(sys.argv[6])+'.txt'
		os.system(cmd)
		cmd = 'mv SERVER_SENDING'+str(i)+'.log results/'+str(sys.argv[5])+'/send_SERVER'+str(i)+'_'+str(sys.argv[4])+'_'+str(sys.argv[6])+'.log'
		os.system(cmd)
		
        cmd = "echo \"STOP\" >> /home/rezmo/opendaylight/Inputs.txt"
        os.system(cmd)
        sleep(5)
        net.stop()
if __name__ == '__main__':
        setLogLevel( 'info' )
        topology()




